<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: adminTables.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.6 $
' Purpose:	edit config options
' Author:		Lawrence Walters
'
'	modified:
'	2005-08-03	LLW	added journals, backgroundMedias to editable table list
'	2005-10-24	LLW moved treatments to adminTablesWithNotes.asp
'	2005-11-20	LLW added displayOrder, delete option
'	2006-01-09	LLW	added new tables
'	2006-01-17	LLW	more table list changes...removed utmDatums table
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Admin Config Options"
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%

RequireLogin()
RequireAdmin()

dim message, errors, level, oldNumLevels, rs, sql, newName, newDisplayOrder, i, table, tables
set errors = server.createobject("Scripting.Dictionary")
set rs = server.createobject("ADODB.Recordset")
tables = array("affiliationtypes", "climates", "countries", "ecosystems", "environments", "experimentalPotSizes", "experimentalUnits", "fungiSources", "inoculationMethods",  "growthMediums", "journals", "mycorrhizaeTypes", "nonMycoControls", "plantGrowthHabits", "plantLifeHistories", "plantPhotoPaths", "plantSources", "responses", "soilNutrientMeasurements", "soilNutrientTypes", "soilNutrientUnits", "sterilizationMethods")

if len(request.form("table")) > 0 then
	table = request.form("table")
elseif len(request.querystring("table")) > 0 then
	table = request.querystring("table")
else
	table = "responses"
end if

' user clicked add
if request.form("Add") = "Add" then
	if len(request.form("table")) > 0 and len(request.form("newName")) > 0 then
		updateTable = request.form("table")
		newName = Request.Form("newName")
		newDisplayOrder = Request.Form("newDisplayOrder")
		if not isnumeric(newDisplayOrder) then newDisplayOrder = "null"		' make sure the user enters a number
		
		sql = "insert into [" & updateTable & "] ([name], [displayOrder]) values ('" & newName & "', " & newDisplayOrder & ")"
		'response.write sql & "<BR>"
		gConn.execute sql
	end if

' user clicked update
elseif request.form("Update") = "Update" then
	if len(request.form("table")) > 0 then
		updateTable = request.form("table")
		
		' for each level
		for each objItem in Request.Form
			if left(objItem, len(DB_FIELD & "id")) = DB_FIELD & "id" then
				id = mid(objItem, len(DB_FIELD & "id") + 1)
				newName = Request.Form(objItem)
				newDisplayOrder = Request.Form(DB_FIELD & "order" & id)
				if not isnumeric(newDisplayOrder) then newDisplayOrder = "null"
				
				sql = "update [" & updateTable & "] set [name] = '" & newName & "', [displayOrder] = " & newDisplayOrder & " where [id] = " & id
				'response.write sql & "<BR>"
				gConn.execute sql
			end if
		next
	end if
' handle delete here
elseif len(request.querystring("delete")) > 0 then
	if isnumeric(request.querystring("delete")) and len(request.querystring("table")) > 0 then
		dbDelete request.querystring("table"), request.querystring("delete"), errors
		message = "Item deleted from table <b>" & request.querystring("table") & "</b>"
	end if
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<!-- #INCLUDE FILE="include/adminHeader.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<table width=100% border=0>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=4 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=4><% = message %></td>
	</tr>
<%
end if
%>
	<tr><td colspan=4 style="font-weight: bold; font-size: 20px">Table: <% = table %></td></tr>
	<tr><td colspan=4>Select another table:<select name="table" onchange="this.form.submit()"><% 
	for i = lbound(tables) to ubound(tables)
		response.write "<option value='" & tables(i) & "'"
		if tables(i) = table then response.write " selected"
		response.write ">" & tables(i) & "</option>" & vbcrlf
	next
	%></select></td></tr>
	<tr>
		<td width=10% class="edHeader">ID</td>
		<td width=70% class="edHeader">Value</td>
		<td width=10% class="edHeader">Order</td>
		<td width=10% class="edHeader">&nbsp;</td>
	</tr>
<%
' list each treatment set, the treatment levels, and then textboxes to enter results
sql = "select [id], [name], [displayOrder] from " & table & " order by [displayOrder], [name]"
'response.write sql
rs.open sql, gConn, adOpenForwardOnly
do while not rs.eof
	response.write "<tr>" & vbcrlf
	response.write "<td valign=top>" & rs("id") & "</td>" & vbcrlf
	response.write "<td valign=top><input type=textbox name='" & DB_FIELD & "id" & rs("id") & "' value='" & rs("name") & "' size=50></td>" & vbcrlf
	response.write "<td valign=top><input type=textbox name='" & DB_FIELD & "order" & rs("id") & "' value='" & rs("displayOrder") & "' size=3></td>" & vbcrlf
	response.write "<td valign=top><input type=button value=""Delete"" onclick=""if(ConfirmDelete()) {document.location='adminTables.asp?table=" & table & "&delete=" & rs("id") & "'}""></td>"
	response.write "</tr>" & vbcrlf
	rs.movenext
loop
rs.close
set rs = nothing
%>
	<tr>
		<td colspan=99><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Update" value="Update"></td>
	</tr>
	<tr>
		<td colspan=99>&nbsp;</td>
	</tr>
	<tr>
		<td valign=top>New</td>
		<td valign=top><input type=textbox name='newName' value='' size=50>&nbsp;<input type=textbox name='newDisplayOrder' value='' size=3>&nbsp;<input type="submit" name="Add" value="Add"></td>
	</tr>

</table>
</form>
<!-- #INCLUDE FILE="include/adminFooter.inc.asp" -->
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

