<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExpResults.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.5 $
' Purpose:	enter results of experiment
' Author:		Lawrence Walters
'
'	modified:
'	2005-08-03	LLW	removed myc/ctl - only one result set per response variable now.
'	2005-10-24	LLW changed warning font
'	2006-04-29	LLW	changed ordering of treatment sets
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Data Entry Step 8 - Experiment Results"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors, level, oldNumLevels, rs, rs2, sql, id, field, fields, i, rowHighlight
fields = array("mean", "stdError", "stdDev", "confInter95", "lsd", "numReplicates")
set errors = server.createobject("Scripting.Dictionary")

RequireLogin()

' see if experiment id is set
if len(Request.Querystring(DB_FIELD & "id")) > 0 then
	session("experimentId") = Request.Querystring(DB_FIELD & "id")

' if no experiment in the session, then redirect to experiment list page
elseif len(session("experimentId")) = 0 then
	response.redirect "edExperimentList.asp"
end if

' user clicked next
if request.form("Finish") = "Finish" then
	' for each level
	for each objItem in Request.Form
		for i = lbound(fields) to ubound(fields)
			if left(objItem, len(DB_FIELD & fields(i))) = DB_FIELD & fields(i) then
				id = mid(objItem, len(DB_FIELD & fields(i)) + 1)
				if len(Request.Form(objItem)) = 0 then
					value = "null"
				else
					value = Request.Form(objItem)
				end if
				
				field = fields(i)

					sql = "update expResults set " & field & " = " & value & " where id = " & id
					'response.write sql & "<BR>"
	
					on error resume next
					gConn.execute sql
					if err.number <> 0 then
						if not isnumeric(value) then
							text = "You might have had some non numeric data. Please check it out. "
						end if
						errors.add errors.count + 1, text & err.description
						error.clear
					end if
					on error goto 0
			end if
		next
	next
	
	'redirect to next page
	if errors.count = 0 then
		response.redirect "edExperimentList.asp"
		response.end
	end if
	
' user clicked back 
elseif request.form("Back") = "Back To Experiment List" then
	'redirect to paper page
	response.redirect "edExperimentList.asp"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = Session("experimentId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100% border=0 cellpadding=2 cellspacing=0>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=3 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=3><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td class="warning" colspan=4>Note: your session will timeout in 20 minutes. If you cannot finish in that time, hit "finish" to save data, and then "results" to come back to this page.</td>
	</tr>
	<tr>
		<td width=20% class="edHeader">Treatment Set</td>
		<td width=21% class="edHeader">Response Variables</td>
		<td width=29.5% class="edHeader" style="text-align: center">Results</td>
	</tr>
<%
' list each treatment set, the treatment levels, and then textboxes to enter results
' original

outputResultForm 167

sub outputResultForm(experimentId)
	dim rsTreatments
	dim arrLevels()
	' how many treatments variables?
	' get treatments in order
	sql = "select distinct treatmentId, treatments.name, treatments.displayOrder from expTreatments, treatments where experimentId = " & experimentId & " and expTreatments.treatmentid = treatments.id order by treatments.displayOrder"
	'displaySQL sql
	set rsTreatments = server.createobject("ADODB.Recordset")
	set rsLevels = server.createobject("ADODB.Recordset")
	set dictTreatments = server.createobject("scripting.dictionary")
	
	rsTreatments.Open sql, gConn, adOpenStatic
	do while not rsTreatments.eof
		' get all the levels for this treatment
		sql2 = "select [level] from expTreatments where treatmentId = " & rsTreatments("treatmentId") & " and experimentId = " & experimentId & " order by [level]"
		'displaySQL sql2
		rsLevels.Open sql2, gConn, adOpenForwardOnly
		set dictLevel = server.createobject("scripting.dictionary")
		do while not rsLevels.eof
			' add levels to a keyed array of some sort?
			dictLevel.add CStr(rsLevels.fields("level").value), rsLevels.fields("level").value
			rsLevels.movenext
		loop
		rsLevels.close
		
		' add these levels to a parent dictionary
		dictTreatments.add CStr(rsTreatments.fields("treatmentId").value), dictLevel
		
		rsTreatments.movenext
	loop
	rsTreatments.Close
	
	' get levels in order
	set dictSQL = server.createobject("scripting.dictionary")
	
	' for each treatment variable
	for each treatmentId in dictTreatments.keys
		' make a sql statement that restricts, do it in order, last to first
		BuildSQLDict experimentId, treatmentId, dictSQL, dictTreatments(treatmentId)
	next
	
	response.write "<table>"
	for each sql in dictSQL.items
		if trtSetRowClass = "treatmentSetEven" then
			trtSetRowClass = "treatmentSetOdd"
		else
			trtSetRowClass = "treatmentSetEven"
		end if

		rsTreatments.Open sql, gConn, adOpenStatic
		'displaySQL "select * from expTrtSetSummary where id in (" & sql & ") order by displayOrder"
		OutputTreatmentSet experimentId, trtSetRowClass, rsTreatments("id")
		rsTreatments.close
	next
	response.write "</table>"
end sub

sub BuildSQLDict(experimentId, treatmentId, byref dictSQL, byref dictLevels)
	dim mySQL
	'response.write "BuildSQL Dictionary: " & experimentId & " / " & treatmentId & "<br>"
	
	set myDict = server.createobject("scripting.dictionary")
	if dictSQL.count = 0 then
		dictSQL.add 1, ""
	end if

	for each mySQL in dictSQL.items
		for each level in dictLevels
			'response.write "BuildSQLDict: " & makesql(mySQL, experimentId, treatmentId, level) & "</br>"
			myDict.add myDict.count + 1, makesql(mySQL, experimentId, treatmentId, level)
		next
	next
	set dictSQL = myDict
end sub

function makesql(firstSQL, newExperimentId, newTreatmentId, newLevel)
	sql = "select id from expTrtSetSummary where treatmentId = " & newTreatmentId & " and experimentId = " & newExperimentId & " and [level] = '" & newLevel & "'"
	
	if len(firstSQL) > 0 then
		sql = sql & " and id in (" & firstSQL & ")"
	end if
	makesql = sql
end function

sub OutputTreatmentSet(experimentId, rowClass, treatmentSetId)
	set rs2 = server.createobject("ADODB.recordset")
	fields = array("mean", "stdError", "stdDev", "confInter95", "lsd", "numReplicates")
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' treatment set
	'
	' each row contains treatments, responses, and input boxes
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	response.write "<tr class='" & rowClass & "'>" & vbcrlf

	
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' treatments summary
	'
	' name and levels
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	response.write "<td class='bdrTop' style='vertical-align: top'><table width=100% border=0 cellpadding=2 cellspacing=0 >" & vbcrlf
	' header
	response.write "<tr><td class='resultHeader'>Treatment</td>" & vbcrlf
	response.write "<td class='resultHeader'>Level</td></tr>" & vbcrlf
	sql = "select * from expTrtSetSummary where experimentId = " & experimentId & " and id = " & treatmentSetId & " order by displayOrder"
	rs2.Open sql, gConn, adOpenForwardOnly
	do while not rs2.eof
		response.write "<TR>" & vbcrlf
		' treatment name
		response.write "<td class='bdrTopThin edSmall' valign=top>" & rs2("name") & "</td>" & vbcrlf
		
		' treatment level
		response.write "<td class='bdrTopThin edSmall' valign=top>" & rs2("level") & "</td>" & vbcrlf
		response.write "</TR>" & vbcrlf
		rs2.movenext
	loop 
	rs2.close
	response.write "</table></td>" & vbcrlf

	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' results
	'
	' response variable name and values
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	
	' results input - new cell
	response.write "<td colspan=3 valign=top class='bdrTop'>"
	
	' sub table
	response.write "<table width=100% border=0 cellpadding=2 cellspacing=0><tr>" & vbcrlf
	
	' header
	response.write "<td class='resultHeader'>Response</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Mean</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Std Error</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Std Dev</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>95% CI</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>LSD</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'># Replicates</td>" & vbcrlf
	response.write "</tr>" & vbcrlf
	
	'todo: change from order by name to order by displayOrder
	' after new form of this view is copied to server
	sql = "select * from expResultSummary where experimentId = " & experimentId & " and expTrtSetId = " & treatmentSetId & " order by name"
	rs2.Open sql, gConn, adOpenForwardOnly
	do while not rs2.eof
		
		if rowHighlight = "odd" then
			rowHighlight = "even"
		else
			rowHighlight = "odd"
		end if
	
		response.write "<TR class='" & rowHighlight & "'>" & vbcrlf
		
		' response variable name
		response.write "<td class='edSmall'>" & rs2("name") & "</td>" & vbcrlf
		
		' results - mean, std Error and # replicates
		for i = lbound(fields) to ubound(fields) 
			response.write "<td class='resultInput'><input type=textbox class='edSmallTextBox' name='" & DB_FIELD & fields(i) & rs2("id") & "' value='" & rs2(fields(i)) & "' size='3'></td>" & vbcrlf
		next
		response.write "</TR>" & vbcrlf
		rs2.movenext
	loop 
	rs2.close	
	response.write "</table></td>" & vbcrlf
	response.write "</tr>" & vbcrlf
	
end sub


sub displaySQL(sql)
	set rs = server.createobject("adodb.recordset")
	
	rs.Open sql, gConn, adOpenStatic
	
	if rs.state = adStateOpen then
		rs.movelast
		records = rs.recordcount
		numHierarchies = rs.recordcount
		rs.movefirst
				
		response.write "<br><br><table id=""results"">"
		response.write "<tr><td colspan=""99"">SQL: " & sql & "</td></tr>"
		response.write "<tr><td colspan=""99"">Records: " & records & "</td></tr>"
		response.write "<tr>"
		for each field in rs.fields
			response.write "<th>" & field.name & "</th>" & vbcrlf
		next
		response.write "</tr>"
		
		response.write "<tr>"
		do while not rs.eof
			response.write "<tr>"
			for each field in rs.fields
				response.write "<td>" & field.value & "</td>" & vbcrlf
			next
			rs.movenext
			response.write "</tr>"
		loop
		response.write "</table>"
	else
		response.write "no records returned"
	end if
end sub
%>
	<tr>
		<td colspan=99>&nbsp;</td>
	</tr>

	<tr>
		<td colspan=99><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back To Experiment List">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Finish" value="Finish"></td>
	</tr>
</table>
</form>

<!-- #INCLUDE FILE="include/footer.inc.asp" -->

