<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExpResponses.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.7 $
' Purpose:	select responses tracked in experiment
' Author:		Lawrence Walters
'
'	modified:
'	2005-07-29	LLW	fixed the way responses were listed, so all are shown now
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Data Entry Step 7 - Experiment Responses"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors, responseId, state, oldNumLevels, rs, rs2, levelsChanged, cnt, numTreatments, sqlFields, sqlFrom, sqlWhere, sqlOrder, expTrtSetId, sql
set errors = server.createobject("Scripting.Dictionary")
set rs = server.createobject("ADODB.Recordset")
set rs2 = server.createobject("ADODB.Recordset")

RequireLogin()

' user clicked next
if request.form("Next") = "Save and move to next page" then
	levelsChanged = false
	
	' remove all responses first
	gConn.execute "delete from expResponses where experimentId = " & session("experimentId")
	
	' for each response
	for each objItem in Request.Form
		if left(objItem, len(DB_FIELD & "responseId")) = DB_FIELD & "responseId" then
			'get treatment id
			responseId = mid(objItem, len(DB_FIELD & "responseId") + 1)
			state = Request.Form(objItem)
			
			'add response here
			if state = "on" then			' it will probably never be anything else, but just in case
				gConn.execute "insert into expResponses (experimentId, responseId) values (" & session("experimentId") & ", " & responseId & ")"
			end if
		end if
	next

	' delete all results
	gConn.Execute "delete from expResults where experimentId = " & session("experimentId")
	
	' add a result for every response/treatment set combo
	gConn.Execute "insert into expResults (experimentId, expTrtSetId, responseId, userId, dateEntered) SELECT expResponses.experimentId, expTrtSets.id, expResponses.responseId, " & session("userId") & ", Now() FROM expResponses INNER JOIN expTrtSets ON expResponses.experimentId = expTrtSets.experimentId where expResponses.experimentId = " & session("experimentId")
	
	'redirect to next page
	response.redirect "edExpResults.asp"
	response.end
	
' user clicked back 
elseif request.form("Back") = "Back" then
	'redirect to paper page
	response.redirect "edExpTreatmentLevels.asp"
	
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = Session("experimentId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100% border='0'>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=5 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=5><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td class="note">Units of measurement do not matter because we will always be comparing relative effect sizes. Select response variables below regardless of units or method of measurement</td>
	</tr>
<%
'list old papers here with edit links
sql = "select responses.id as responseId, responses.name as responseName, iif(IsNull(a.experimentId), '', 'checked') as checked from responses left outer join (select * from expResponses where experimentId = "  & session("experimentId") & ") a on responses.id = a.responseId order by responses.name"

rs.Open sql, gConn, adOpenStatic
numCols = 2
rowsPerColumn = CInt(rs.RecordCount/numCols)
currentCol = 1
currentRow = 1
width = 100/numCols
%>
	<tr>
		<td colspan='99'><table cellpadding=2 cellspacing=0>
			<tr>
				<Td valign='top' width="<% = width %>%"><table cellpadding=0 cellspacing=2>
<%
dim rowClass
do while not rs.eof
	if rowClass="even" then
		rowClass="odd"
	else
		rowClass="even"
	end if

	response.write "<TR class='" & rowClass & "'>"   & vbcrlf
	
	response.write "<td valign=top>" & vbcrlf
	
	' write checkbox
	response.write "<input type='checkbox' class='edSmallCheckbox' name='" & DB_FIELD & "responseId" & rs("responseId") & "' " & rs("checked") & ">"
	
	response.write "</td>" & vbcrlf
	response.write "<td width=100% valign=top class='edSmall'>" & rs("responseName") & "</td>" & vbcrlf
	response.write "</TR>" & vbcrlf
	rs.movenext
	currentRow = currentRow + 1
	if currentRow > rowsPerColumn and not rs.eof then
		response.write "</table></td>"
		response.write "				<Td valign='top' width='" & width & "%'><table cellpadding=0 cellspacing=2>"		
		currentRow = 1
	end if	
loop
response.write "</table></td></tr></table></td></tr>"
rs.close
set rs = nothing
%>
	<tr>
		<td colspan=2>&nbsp;</td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

