<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExpTreatmentLevels.asp,v $
' $Date: 2006/01/19 05:16:39 $
' $Revision: 1.5 $
' Purpose:	main data entry page
' Author:		Lawrence Walters
'
'	modified:
'	2005-07-29	LLW	levels are no longer required to be numbers
'	2005-10-24	LLW added treatment notes to display
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Data Entry Step 6 - Treatment Levels"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors, expTreatmentId, level, oldNumLevels, rs
set errors = server.createobject("Scripting.Dictionary")
set rs = server.createobject("ADODB.Recordset")

RequireLogin()

' user clicked next
if request.form("Next") = "Save and move to next page" then
	' for each level
	for each objItem in Request.Form
		if left(objItem, len(DB_FIELD & "expTreatmentId")) = DB_FIELD & "expTreatmentId" then
			'get expTreatment id
			expTreatmentId = mid(objItem, len(DB_FIELD & "expTreatmentId") + 1)
			level = Request.Form(objItem)

			on error resume next
			if len(level) = 0 then
				errors.add errors.count + 1, "Please do not use a blank level."
			end if

			gConn.execute "update expTreatments set [level] = '" & level & "', userId = " & session("userId") & ", dateEntered = Now() where id = " & expTreatmentId
			if err.number <> 0 then
				if not isnumeric(value) then
					text = "You might have had some non numeric data. Please check it out. "
				end if
				errors.add errors.count + 1, text & err.description
				error.clear
			end if
			on error goto 0


		end if
	next

	'redirect to next page
	if errors.count = 0 then
		response.redirect "edExpResponses.asp"
		response.end
	end if

' user clicked back
elseif request.form("Back") = "Back" then
	'redirect to paper page
	response.redirect "edExpTreatments.asp"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = Session("experimentId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100% border="0">
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=3 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=3><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td class="warning" colspan=4>Note: your session will timeout in 20 minutes. If you cannot finish in that time, hit "next" to save data, and then "back" to come back to this page.</td>
	</tr>
	<tr>
		<td width=20% class="edHeader">Treatment</td>
		<td width=5% class="edHeader">#</td>
		<td width=25% class="edHeader">Level</td>
		<td width=50% class="edHeader">Notes</td>
	</tr>
<%
'list old papers here with edit links
dim levelCount, lastTreatmentId, sql, className
levelCount = 0
lastTreatmentId = -1
sql = "select expTreatments.id as id, treatments.id as treatmentId, treatments.name as treatmentName, treatments.description as treatmentNotes, [level] from treatments left outer join expTreatments on treatments.id = expTreatments.treatmentId where expTreatments.experimentId = " & session("experimentId") & " order by treatments.displayOrder, expTreatments.id, [level] asc"

rs.Open sql, gConn, adOpenForwardOnly
do while not rs.eof
	if lastTreatmentId <> rs("treatmentId") then
		levelCount = 0
		className = "rowBreak"
	else
		className = ""
	end if
	levelCount = levelCount + 1
	lastTreatmentId = rs("treatmentId")

	response.write "<TR>" & vbcrlf
	response.write "<td class=" & className & " valign=top>"

	' show the treatment name once
	if levelCount = 1 then
		response.write rs("treatmentName")
	else
		response.write "&nbsp;"
	end if

	response.write "</td>" & vbcrlf

	response.write "<td class=" & className & " valign=top>" & levelCount & "</td>" & vbcrlf

	' write input box for level
	response.write "<td class=" & className & " valign=top><input type=text name=" & DB_FIELD & "expTreatmentId" & rs("id") & " value=""" & rs("level") & """ size=10></td>" & vbcrlf
	response.write "</td>" & vbcrlf

	' also show notes only once
	if levelCount = 1 then
		response.write "<td class='" & className & " note' valign=top>"
		response.write rs("treatmentNotes")
		response.write "</td>" & vbcrlf
	end if

	response.write "</TR>" & vbcrlf
	rs.movenext
loop
rs.close
set rs = nothing
%>
	<tr>
		<td colspan=99>&nbsp;</td>
	</tr>

	<tr>
		<td colspan=99><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

