<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExpTreatments.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.7 $
' Purpose:	main data entry page
' Author:		Lawrence Walters
'
'	modified:
'	2005-07-29	LLW	fixed the way treatments were listed, so all are shown now
'	2005-10-24	LLW changed warning font
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Data Entry Step 5 - Experiment Treatments"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors, treatmentId, newNumLevels, oldNumLevels, rs, rsExpTrtSets, rsExpTreatments, levelsChanged, cnt, numTreatments, sqlFields, sqlFrom, sqlWhere, sqlOrder, expTrtSetId, sql, i
dim tableAlias, treatmentSetKey, isControlSet, nonControlTreatmentKeysBySetId, controlSetsByTreatmentKey, id
set errors = server.createobject("Scripting.Dictionary")
set nonControlTreatmentKeysBySetId = server.createobject("Scripting.Dictionary")
set controlSetsByTreatmentKey = server.createobject("Scripting.Dictionary")
set rs = server.createobject("ADODB.Recordset")
set rsExpTrtSets = server.createobject("ADODB.Recordset")
set rsExpTreatments = server.createobject("ADODB.Recordset")

RequireLogin()

' user clicked next
if request.form("Next") = "Save and move to next page" then
	levelsChanged = false
	' for each level
	for each objItem in Request.Form
		if left(objItem, len(DB_FIELD & "numLevels")) = DB_FIELD & "numLevels" then
			'get treatment id
			treatmentId = mid(objItem, len(DB_FIELD & "numLevels") + 1)
			newNumLevels = CLng(Request.Form(objItem))
			
			'check current count in database
			rs.open "select numLevels from expTreatmentLevelCount where experimentId = " & session("experimentId") & " and treatmentId = " & treatmentId, gConn, adOpenForwardOnly
			if not rs.eof then
				oldNumLevels = CLng(rs("numLevels"))
			else
				oldNumLevels = 0
			end if
			rs.close

			'debugging
			'response.write "difference: " & (newNumLevels - oldNumLevels) & "<br>"
			'if low, add new ones
			if oldNumLevels < newNumLevels then
				levelsChanged = true
				' add new levels
				do while oldNumLevels < newNumLevels
					' first treatment for types of inoculum (treatment id = 4) should always be "control"
					if oldNumLevels = 0 and treatmentId = 4 then
						newVal = "control"
					else
						newval = ""
					end if
					
					gConn.Execute "insert into expTreatments (experimentId, treatmentId, [level], userId, dateEntered) values(" & session("experimentId") & ", " & treatmentId & ", '" & newVal & "', " & session("userId") & ", Now())" 
					oldNumLevels = oldNumLevels + 1
				loop
			
			'if high, remove last one
			elseif oldNumLevels > newNumLevels then
				levelsChanged = true
				'remove current levels, starting with highest level
				rsExpTreatments.open "select * from expTreatments where experimentId = " & session("experimentId") & " and treatmentId = " & treatmentId & " order by [level] desc", gConn, adOpenDynamic, adLockOptimistic
				
				do while not rsExpTreatments.eof and oldNumLevels > newNumLevels
					rsExpTreatments.delete
					rsExpTreatments.update
					rsExpTreatments.movenext
					oldNumLevels = oldNumLevels - 1
				loop
				rsExpTreatments.close
				set rsExpTreatments = nothing
			end if
		end if
	next

	'when levels have changed
	if levelsChanged then
		'todo: allow changes
		' delete all treatment sets and variations for this experiment
		' because referential integrity is enforced, this will delete results and variations
		gConn.execute "delete from expTrtSets where experimentId = " & session("experimentId")
		
		' create treatment sets for all variations
		' determine how many different treatments for this experiment
		rs.open "select treatments from expTreatmentsPerExperiment where experimentId = " & session("experimentId"), gConn, adOpenForwardOnly
		if not rs.eof then
			numTreatments = CLng(rs("treatments"))
			rs.close
			' build a query with every combination of level for the given treatments
			' sort by level asc
			
			' first get all of the treatments for this experiment
			rs.open "select distinct treatmentId from expTreatments where experimentId = " & session("experimentId") & " order by treatmentId asc", gConn, adOpenForwardOnly
			
			' now build dynamic sql that will be an outer join of every treatment/level combination.
			' this will result in a query where the there are columns for each treatment id selected above
			' and the value of those columns will be different levels. Each row will represent a treatment
			' set with a unique combination of treatments and levels
			' the unrestricted outer join will create all possible combinations (our factorial)
			cnt = 1
			sqlFields = "select "
			sqlFrom = " from "
			sqlWhere = " where "
			sqlOrder = " order by "
			do while not rs.eof
				if cnt > 1 then
					sqlFields = sqlFields & ", "
					sqlFrom = sqlFrom & ", "
					sqlWhere = sqlWhere & " and "
					sqlOrder = sqlOrder & ", "
				end if
				tableAlias = "expTreatments" & cnt
				' select fields - use sequential table alias
				sqlFields = sqlFields & tableAlias & ".id as treatmentId_" & rs("treatmentId")
				sqlFields = sqlFields & ", " & tableAlias & ".level as treatmentId_" & rs("treatmentId") & "_level"
				
				' add table - give new sequential alias
				sqlFrom = sqlFrom & "expTreatments " & tableAlias
				
				' where clause - restrict to correct experiment and this treatment
				sqlWhere = sqlWhere & tableAlias & ".experimentId = " & session("experimentId") & " and " & tableAlias & ".treatmentId = " & rs("treatmentId")
				
				' order by clause - order by level ascending
				sqlOrder = sqlOrder & tableAlias & ".level asc"
				
				rs.movenext
				cnt = cnt + 1
			loop
			rs.close
			
			'response.write sqlFields & sqlFrom & sqlWhere & sqlOrder & "<BR>"
			
			rs.open sqlFields & sqlFrom & sqlWhere & sqlOrder, gConn, adOpenForwardOnly
			do while not rs.eof
				' create new treatment set
				set rsExpTrtSets = server.createobject("ADODB.Recordset")
				rsExpTrtSets.open "expTrtSets", gConn, adOpenKeySet, adLockOptimistic, adCmdTable
				rsExpTrtSets.AddNew
				rsExpTrtSets("experimentId") = session("experimentId")
				rsExpTrtSets("userId") = session("userId")
				rsExpTrtSets("dateEntered") = Now()
				rsExpTrtSets.Update
				expTrtSetId = rsExpTrtSets("id")
				rsExpTrtSets.Close
				'response.write "Treatment set id: " & expTrtSetId & "</br>"
				
				' this is the generated key that will uniquely identify a treatment set based on its non-controllable treatmenats
				' (meaning any non-mycorrhizal treatments will create the key)
				treatmentSetKey = ""
				
				' is this current set a control? determines which collection it is added to (controlSets or nonControlSets)
				isControlSet = false
				
				' add individual records to that set
				for cnt = 0 to rs.Fields.Count - 1 step 2
					'response.write rs.Fields(cnt).Name & " = " & rs(cnt) & "/" & rs(cnt + 1) & " "

					sql = "insert into expTrtVariations (expTrtSetId, expTreatmentId, userId, dateEntered) values (" & expTrtSetId & ", " & rs(cnt) & ", " & session("userId") & ", Now())"
					gConn.execute sql
					
					' add this treatment id to the key if it is not our control treatment (id = 4)
					' note that the colums of the query we are reading are like treatmentId_xxx, treatmentId_xxx_level
					if rs.Fields(cnt).Name = "treatmentId_4" then
						if rs(cnt + 1) = "control" then
							isControlSet = true
						end if
					else
						treatmentSetKey = treatmentSetKey & rs(cnt) & "_"
					end if
										
				next
				'response.write "<br/>treatmentSetKey = " & treatmentSetKey & " / isControlSet = " & isControlSet & "</br>"
				
				' add this treatment set id to the proper collection
				if isControlSet then
					' note this collection is keyed on the treatment set key, with the value being the treatment set id
					controlSetsByTreatmentKey.Add treatmentSetKey, expTrtSetId
				else
					' while this collection has the treatment sets as the id, and the treatment set key as the value
					' expTrtSetId is unique here, but the treatmentSetKey can be non unique in this collection if
					' there are more than two levels of the control
					nonControlTreatmentKeysBySetId.Add expTrtSetId, treatmentSetKey
				end if
				
				rs.movenext
			loop
			
			' now loop through each of our non-control treatment sets, and update the expTrtSets record
			' with the control treatment set id using the two collections created above
			for each id in nonControlTreatmentKeysBySetId
				'response.write "Treatment Set Id: " & id _
				'	& " has Key  " & nonControlTreatmentKeysBySetId(id) _
				'	& " which has control set id of " & controlSetsByTreatmentKey(nonControlTreatmentKeysBySetId(id)) & "<br />"
				sql = "update expTrtSets set ctlTrtSetId = " & controlSetsByTreatmentKey(nonControlTreatmentKeysBySetId(id)) & " where id = " & id
				gConn.execute sql				
			next
		end if
	end if
	
	'redirect to next page
	response.redirect "edExpTreatmentLevels.asp"
	response.end
	

' user clicked back 
elseif request.form("Back") = "Back" then
	'redirect to paper page
	response.redirect "edExperimentHostPlant.asp"

' user clicked "back to experiments" 
elseif request.form("BackToExperiments") = "Back To Experiment List" then
	'redirect to paper page
	response.redirect "edExperimentList.asp"
	
' user came here directly from experiment list page
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	Session("experimentId") = request.querystring(DB_FIELD & "id")
		
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = Session("experimentId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=5 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=5><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td colspan=3>Select the number of experimental factors present in the experiment. The number of levels should include the control.</td>
	</tr>
	<tr>
		<td class="warning" colspan=3>Note: do not change these (or hit "Next") after you have entered results. If you do, all results will be deleted. Even hitting "Next" without making changes will delete your results.</td>
	</tr>
	<tr>
		<td class="edHeader">Treatment</td>
		<td class="edHeader">Number of Levels</td>
		<td class="edHeader"></td>
	</tr>
<%
'show inoculum level - minimum number of levels is 2
sql = "SELECT treatments.id as treatmentId, treatments.name as treatmentName, a.numLevels FROM treatments LEFT JOIN (select * from expTreatmentLevelCount where experimentId = " & session("experimentId") & ") a ON treatments.id = a.treatmentId where treatments.id = 4"
rs.Open sql, gConn, adOpenForwardOnly
do while not rs.eof
	response.write "<TR>"   & vbcrlf
	response.write "<td width=40% valign=top>" & rs("treatmentName") & "</td>" & vbcrlf
	response.write "<td width=40% valign=top>" & vbcrlf
	
	' write selector for number of levels
	response.write "<select name='" & DB_FIELD & "numLevels" & rs("treatmentId") & "'>"  & vbcrlf
	for i = 2 to 10
		' don't allow one level only
		if i <> 1 then
			response.write "<option "
			if i = rs("numLevels") then response.write " selected "
			response.write "value='" & i & "'>" & i & "</option>" & vbcrlf
		end if
	next
	response.write "</select>" & vbcrlf
	
	response.write "</td>" & vbcrlf
	response.write "</TR>" & vbcrlf
	rs.movenext
loop 
rs.close
%>
<!-- show note about required number of levels for inoculum types -->
	<tr>
		<td>&nbsp;</td>
		<td class="note" colspan="2">If you have an uninoculated control and an inoculated treatment then you have two types. The minimum number of levels is two.</td>
	</tr>
<%
'show list of treatments here - not including inoculum level
sql = "SELECT treatments.id as treatmentId, treatments.name as treatmentName, a.numLevels FROM treatments LEFT JOIN (select * from expTreatmentLevelCount where experimentId = " & session("experimentId") & ") a ON treatments.id = a.treatmentId where treatments.id <> 4 order by treatments.displayOrder"

rs.Open sql, gConn, adOpenStatic
numCols = 2
rowsPerColumn = CInt(rs.RecordCount/numCols) + 1
currentCol = 1
currentRow = 1
width=100/numCols
%>
	<tr>
		<td colspan='99'><table cellpadding=5 cellspacing=0>
			<tr>
				<Td valign='top' width="<% = width %>%"><table>
					<tr>
						<td class="edHeader">Treatment</td>
						<td class="edHeader">Levels</td>
					</tr>
<%
dim rowClass
do while not rs.eof
	if rowClass="even" then
		rowClass="odd"
	else
		rowClass="even"
	end if

	response.write "<TR class='" & rowClass & "'>"   & vbcrlf
	
	response.write "<td valign=top class='edSmall'>" & rs("treatmentName") & "</td>" & vbcrlf
	response.write "<td valign=top>" & vbcrlf
	
	' write selector for number of levels
	response.write "<select class='edSmallSelect' name='" & DB_FIELD & "numLevels" & rs("treatmentId") & "'>"  & vbcrlf
	for i = 0 to 10
		' don't allow one level only
		if i <> 1 then
			response.write "<option "
			if i = rs("numLevels") then response.write " selected "
			response.write "value='" & i & "'>" & i & "</option>" & vbcrlf
		end if
	next
	response.write "</select>" & vbcrlf
	
	response.write "</td>" & vbcrlf
	response.write "</TR>" & vbcrlf
	rs.movenext
	currentRow = currentRow + 1
	if currentRow > rowsPerColumn and not rs.eof then
		response.write "</table></td>"
		response.write "				<Td valign='top' width='" & width & "%'><table>" & _
		"			<tr>" & _
		"				<td class='edHeader'>Treatment</td>" & _
		"				<td class='edHeader'>Levels</td>" & _
		"			</tr>"
		currentRow = 1
	end if
loop
response.write "</table></td></tr></table></td></tr>"
rs.close
set rs = nothing
%>
	<tr>
		<td colspan=2>&nbsp;</td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="BackToExperiments" value="Back To Experiment List">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->
