<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperiment.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.8 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
'	modified:
'	2005-07-29	LLW	added some comments, formatted site dropdown to be only 60 characters,
'									added fungal inoculum type and species
'	2005-12-02	LLW	removed conversion link text
'									cut up this page into different pages for each section
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "name"
PageTitle = "Data Entry Step 4a - Experiment Details - General Information"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array("name", "countryId")

'numeric fields
numeric = array("year", "numWeeks")

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true

	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then	valid = ValidateNumeric(numeric, errors)

	if valid then

		'update data
		id = dbInput("experiments", errors)

		if errors.count = 0 then
			Session("experimentId") = id
			'redirect to next page
			response.redirect "edExperimentEcosystem.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()

' user clicked back
elseif request.form("Back") = "Back" then
	'redirect to paper page
	response.redirect "edExperimentList.asp"

' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))

' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>

	<tr><td>&nbsp;</td></tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "name") %>Enter a name for you to keep track of this experiment:</td>
		<td><input type="text" name="<% = DB_FIELD %>name" size=60 value="<% = expData.Item("name") %>"></td>
	</tr>
	<tr>
		<td></td>
		<td class="note">Note: When host plants and/or soil types vary within a single experiment, you should enter them as separate experiments.  Then, give them names such as Experiment 1: Plant sp. A and Experiment 1: Plant sp. B</td>
	</tr>
	<tr><td>&nbsp;</td></tr>
	<tr>
		<td colspan=2 class="edHeader">Where was the experiment conducted?</td>
	</tr>
	<tr>
		<td width="25%"class="edHeader"><% = MarkRequiredField(required, "countryId") %>Country:</td>
		<td width="75%" nowrap><%
			response.write dbBuildSelect("countryId", "select id, name from countries order by displayOrder, name", expData.Item("countryId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "closestCity") %>Closest city/town:</td>
		<td><input type="text" name="<% = DB_FIELD %>closestCity" size=60 value="<% = expData.Item("closestCity") %>"></td>
	</tr>

	<tr><td>&nbsp;</td></tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "year") %>Year initiated:</td>
		<td><input type="text" name="<% = DB_FIELD %>year" size=5 value="<% = expData.Item("year") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "month") %>Month initiated:</td>
		<td nowrap><%
			response.write dbBuildSelect("month", "select id, name from months order by id", expData.Item("month"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "numWeeks") %>Duration:</td>
		<td><input type="text" name="<% = DB_FIELD %>numWeeks" size=5 value="<% = expData.Item("numWeeks") %>">&nbsp;Round to the nearest whole week</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "timeCourseStudy") %>Was this a time course study?</td>
		<td><%
			response.write dbBuildSelect("timeCourseStudy", "", expData.Item("timeCourseStudy"), false, true)
		%>Select Yes if response variables were measured at multiple time points. In this case, you should only enter results from the last time point.</td>
	</tr>



	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

