<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentBackup.asp,v $
' $Date: 2006/01/19 05:16:38 $
' $Revision: 1.2 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
'	modified:
'	2005-07-29	LLW	added some comments, formatted site dropdown to be only 60 characters,
'									added fungal inoculum type and species
'	2005-12-02	LLW	removed conversion link text
'									cut up this page into different pages for each section
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "expSiteId"
PageTitle = "Data Entry Step 4 - Experiment Details"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array("name", "expSiteId")

'numeric fields
numeric = array("year", "numWeeks", "soilMoisture", "soilNitrogen", "soilPhosphorous", "fertTimes", "fertN", "fertP", "fertK")

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true
	
	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then	valid = ValidateNumeric(numeric, errors)
	
	if valid then
	
		'update data
		id = dbInput("experiments", errors)
		
		if errors.count = 0 then
			Session("experimentId") = id
			'redirect to next page
			response.redirect "edExpTreatments.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()
	
' user clicked back 
elseif request.form("Back") = "Back" then
	'redirect to paper page
	response.redirect "edExperimentList.asp"
	
' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))
	
' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
	
	<tr><td colspan=2 class="sectionBreak">General Information</td></tr>
	
	<tr>
		<td width="25%"class="edHeader"><% = MarkRequiredField(required, "expSiteId") %>Where was the experiment conducted?</td>
		<td width="75%" nowrap><%
			response.write dbBuildSelect("expSiteId", "select expSites.id, left(countries.name & ' ' & expSites.State & ' ' & expSites.name & ' ' & easting & ' ' & northing & ' ' & zoneNumber & zoneLetter, 60) from expSites left outer join countries on countries.id = expSites.countryId order by countries.name, expSites.State, expSites.name", expData.Item("expSiteId"), true, false)
		%>&nbsp;<input type="button" value="Edit..." onclick="if(frmMain.<% = DB_FIELD %>expSiteId.options[frmMain.<% = DB_FIELD %>expSiteId.selectedIndex].value > 0) {document.location='edSite.asp?<% = DB_FIELD %>id=' + frmMain.<% = DB_FIELD %>expSiteId.options[frmMain.<% = DB_FIELD %>expSiteId.selectedIndex].value }">&nbsp;&nbsp;&nbsp;<input type="button" value="Add Site" onclick="document.location='edSite.asp'"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "name") %>Enter a name for you to keep track of this experiment:</td>
		<td><input type="text" name="<% = DB_FIELD %>name" size=60 value="<% = expData.Item("name") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "ecosystemId") %>Ecosystem:</td>
		<td><%
			response.write dbBuildSelect("ecosystemId", "select id, name from ecosystems order by name", expData.Item("ecosystemId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "climateId") %>Climate:</td>
		<td><%
			response.write dbBuildSelect("climateId", "select id, name from climates order by name", expData.Item("climateId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "environmentId") %>Experiment environment:</td>
		<td><%
			response.write dbBuildSelect("environmentId", "select id, name from environments order by name", expData.Item("environmentId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "year") %>Year initiated:</td>
		<td><input type="text" name="<% = DB_FIELD %>year" size=5 value="<% = expData.Item("year") %>"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "month") %>Month initiated:</td>
		<td><input type="text" name="<% = DB_FIELD %>month" size=5 value="<% = expData.Item("month") %>"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "sterilizationMethodId") %>Sterilization Method:</td>
		<td><%
			response.write dbBuildSelect("sterilizationMethodId", "select id, name from sterilizationMethods order by name", expData.Item("sterilizationMethodId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "numWeeks") %>Duration:</td>
		<td><input type="text" name="<% = DB_FIELD %>numWeeks" size=5 value="<% = expData.Item("numWeeks") %>">&nbsp;weeks</td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "backgroundMediaId") %>Background Media:</td>
		<td><%
			response.write dbBuildSelect("backgroundMediaId", "select id, name from backgroundMedias order by name", expData.Item("backgroundMediaId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "timeCourseStudy") %>Was this a time course study?</td>
		<td><%
			response.write dbBuildSelect("timeCourseStudy", "", expData.Item("timeCourseStudy"), true, true)
		%></td>
	</tr>
	
	
	<tr><td colspan=2 class="sectionBreak">Soil Details</td></tr>
	
	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "mycorrhizaeTypeId") %>Type of Mycorrhizae:</td>
		<td><%
			response.write dbBuildSelect("mycorrhizaeTypeId", "select id, name from mycorrhizaeTypes order by name", expData.Item("mycorrhizaeTypeId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "inoculumTypeId") %>Fungal Inoculum Type:</td>
		<td><%
			response.write dbBuildSelect("inoculumTypeId", "select id, name from inoculumTypes order by name", expData.Item("inoculumTypeId"), true, false)
		%></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "inoculumSpecies") %>Fungal inoculum species:</td>
		<td><textarea cols="50" rows="3" name="<% = DB_FIELD %>inoculumSpecies"><% = expData.Item("inoculumSpecies") %></textarea></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "soilMoisture") %>Soil Moisture:</td>
		<td><input type="text" name="<% = DB_FIELD %>soilMoisture" size=5 value="<% = expData.Item("soilMoisture") %>">&nbsp;%</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "soilNitrogen") %>Soil Nitrogen:</td>
		<td><input type="text" name="<% = DB_FIELD %>soilNitrogen" size=5 value="<% = expData.Item("soilNitrogen") %>">&nbsp;&#181;g/g</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td class="note">Please enter only numerical values ("8.3" not "8.3 ug/g").</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "soilPhosphorous") %>Soil Phosphorous:</td>
		<td><input type="text" name="<% = DB_FIELD %>soilPhosphorous" size=5 value="<% = expData.Item("soilPhosphorous") %>">&nbsp;&#181;g/g</td>
	</tr>	
	<tr>
		<td>&nbsp;</td>
		<td class="note">Please enter only numerical values ("8.3" not "8.3 ug/g").</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "microbialWash") %>Microbial Wash:</td>
		<td><%
			response.write dbBuildSelect("microbialWash", "", expData.Item("microbialWash"), true, true)
		%></td>
	</tr>
	<tr>
		<td class="edHeader" colspan=2>Fertilizer:</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertTimes") %>Number of times applied:</td>
		<td><input type="text" name="<% = DB_FIELD %>fertTimes" size=5 value="<% = expData.Item("fertTimes") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertN") %>Fertilizer N:</td>
		<td><input type="text" name="<% = DB_FIELD %>fertN" size=5 value="<% = expData.Item("fertN") %>">&nbsp;&#181;g/g</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertP") %>Fertilizer P:</td>
		<td><input type="text" name="<% = DB_FIELD %>fertP" size=5 value="<% = expData.Item("fertP") %>">&nbsp;&#181;g/g</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertK") %>Fertilizer K:</td>
		<td><input type="text" name="<% = DB_FIELD %>fertK" size=5 value="<% = expData.Item("fertK") %>">&nbsp;&#181;g/g</td>
	</tr>
	
	
	<tr><td colspan=2 class="sectionBreak">Host Plant Details</td></tr>
	
	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantNative") %>host plant native?</td>
		<td><%
			response.write dbBuildSelect("hostPlantNative", "", expData.Item("hostPlantNative"), false, true)
		%></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantLifeHistoryId") %>Host Plant Life History:</td>
		<td><%
			response.write dbBuildSelect("hostPlantLifeHistoryId", "select id, name from plantLifeHistories order by name", expData.Item("hostPlantLifeHistoryId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantPhotoPathId") %>Host Plant Photosynthetic Pathway:</td>
		<td><%
			response.write dbBuildSelect("hostPlantPhotoPathId", "select id, name from plantPhotoPaths order by name", expData.Item("hostPlantPhotoPathId"), true, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostGenus") %>Host Genus:</td>
		<td><input type="text" name="<% = DB_FIELD %>hostGenus" size=30 value="<% = expData.Item("hostGenus") %>"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostSpecies") %>Host Species:</td>
		<td><input type="text" name="<% = DB_FIELD %>hostSpecies" size=30 value="<% = expData.Item("hostSpecies") %>"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "plantSourceId") %>Plant Source:</td>
		<td><%
			response.write dbBuildSelect("plantSourceId", "select id, name from plantSources order by name", expData.Item("plantSourceId"), true, false)
		%></td>
	</tr>








	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

