<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentBelowGround.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.3 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "growthMediumId"
PageTitle = "Data Entry Step 4d - Belowground Details"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array("mycorrhizaeTypeId")

'numeric fields
numeric = array()

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true

	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then	valid = ValidateNumeric(numeric, errors)

	if valid then

		'update data
		id = dbInput("experiments", errors)

		if errors.count = 0 then
			'redirect to next page
			response.redirect "edExperimentSoilNutrients.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()

' user clicked back
elseif request.form("Back") = "Back" then
	'redirect to first experiment page
	response.redirect "edExperimentConditions.asp"

' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))

' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
	<tr>
		<td colspan=2 class="edHeader">Experiment Name: <% =expData.Item("name") %></td>
	</tr>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>



	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td class="edHeader" width="30%"><% = MarkRequiredField(required, "growthMediumId") %>Growth Medium:</td>
		<td><%
			response.write dbBuildSelect("growthMediumId", "select id, name from growthMediums order by displayOrder, name", expData.Item("growthMediumId"), false, false)
		%></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "mycorrhizaeTypeId") %>Type of Mycorrhizae:</td>
		<td><%
			response.write dbBuildSelect("mycorrhizaeTypeId", "select id, name from mycorrhizaeTypes order by displayOrder, name", expData.Item("mycorrhizaeTypeId"), true, false)
		%></td>
	</tr>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>
	<tr>
		<td colspan=2><table cellpadding="2" cellspacing="2">
			<tr>
				<td colspan=99 class="edHeader" style="text-align: center">Type of Inoculum</td>
			</tr>
			<tr>
				<td colspan=99 class="" style="text-align: center">Select YES or NO only for elements explicitly mentioned by authors as being included or not. Otherwise, select Unknown.</td>
			</tr>
			<tr>
				<td class="edHeader"><% = MarkRequiredField(required, "inocFieldSoil") %>Field Soil:</td>
				<td><%
					response.write dbBuildSelect("inocFieldSoil", "", expData.Item("inocFieldSoil"), false, true)
				%></td>

				<td class="edHeader"><% = MarkRequiredField(required, "inocRoots") %>Roots:</td>
				<td><%
					response.write dbBuildSelect("inocRoots", "", expData.Item("inocRoots"), false, true)
				%></td>
				<td class="edHeader"><% = MarkRequiredField(required, "inocSpores") %>Spores:</td>
				<td><%
					response.write dbBuildSelect("inocSpores", "", expData.Item("inocSpores"), false, true)
				%></td>
			</tr>
			<tr>
				<td class="edHeader"><% = MarkRequiredField(required, "inocMycelia") %>Mycelia:</td>
				<td><%
					response.write dbBuildSelect("inocMycelia", "", expData.Item("inocMycelia"), false, true)
				%></td>
				<td class="edHeader"><% = MarkRequiredField(required, "inocPotCulture") %>Pot Culture:</td>
				<td><%
					response.write dbBuildSelect("inocPotCulture", "", expData.Item("inocPotCulture"), false, true)
				%></td>
			</tr>
		</table></td>
	</tr>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fungiSourceId") %>Source of Fungi:</td>
		<td><%
			response.write dbBuildSelect("fungiSourceId", "select id, name from fungiSources order by displayOrder, name", expData.Item("fungiSourceId"), false, false)
		%></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "inoculumSpecies") %>Fungal inoculum species:</td>
		<td><textarea cols="50" rows="3" name="<% = DB_FIELD %>inoculumSpecies"><% = expData.Item("inoculumSpecies") %></textarea></td>
	</tr>
	<tr>
		<td></td>
		<td class="note">Enter all species included in experiment, even if the composition varies by treatment. Do not abbreviate - fully spell out genus and specific epithet. Enter BEG/INVAM accession number if applicable.</td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "nonMycoControlId") %>Addition of non-mycorrhizal organisms to entire experiment?</td>
		<td><%
			response.write dbBuildSelect("nonMycoControlId", "select id, name from nonMycoControls order by displayOrder, name", expData.Item("nonMycoControlId"), false, false)
		%></td>
	</tr>

	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

