<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentEcosystem.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.4 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "ecosystemId"
PageTitle = "Data Entry Step 4b - Target Ecosystem of Inference"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array()

'numeric fields
numeric = array()

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true

	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then	valid = ValidateNumeric(numeric, errors)

	if valid then

		'update data
		id = dbInput("experiments", errors)

		if errors.count = 0 then
			'redirect to next page
			response.redirect "edExperimentConditions.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()

' user clicked back
elseif request.form("Back") = "Back" then
	'redirect to first experiment page
	response.redirect "edExperiment.asp"

' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))

' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
	<tr>
		<td colspan=2 class="edHeader">Experiment Name: <% =expData.Item("name") %></td>
	</tr>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>



	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "ecosystemId") %>Vegetation Type:</td>
		<td><%
			response.write dbBuildSelect("ecosystemId", "select id, name from ecosystems order by displayOrder, name", expData.Item("ecosystemId"), false, false)
		%><input type="button" value="Add Type..." onclick="document.location='edAddVegType.asp'"></td>
	</tr>

	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "climateId") %>Climate:</td>
		<td><%
			response.write dbBuildSelect("climateId", "select id, name from climates order by displayOrder, name", expData.Item("climateId"), false, false)
		%>&nbsp;For greenhouse or growth chamber experiments, choose "ARTIFICIAL"</td>
	</tr>
	<tr>
		<td></td>
		<td class="note">An explanation of classes can be found at <a href="http://www.geofictie.nl/ctkoppen.htm">http://www.geofictie.nl/ctkoppen.htm</a></td>
	</tr>

	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

