<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentHostPlant.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.5 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "climateId"
PageTitle = "Data Entry Step 4f - Host Plant Details"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array("name", "expSiteId")

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true
	

	if valid then
	
		'update data
		id = dbInput("experiments", errors)
		
		if errors.count = 0 then
			'redirect to next page
			response.redirect "edExpTreatments.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()
	
' user clicked back 
elseif request.form("Back") = "Back" then
	'redirect to first experiment page
	response.redirect "edExperimentSoilNutrients.asp"
	
' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))
	
' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
	<tr>
		<td colspan=2 class="edHeader">Experiment Name: <% =expData.Item("name") %></td>
	</tr>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td class="edHeader" width="40%"><% = MarkRequiredField(required, "hostPlantNative") %>Host plant native?</td>
		<td><%
			response.write dbBuildSelect("hostPlantNative", "", expData.Item("hostPlantNative"), false, true)
		%></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantLifeHistoryId") %>Host Plant Life History:</td>
		<td><%
			response.write dbBuildSelect("hostPlantLifeHistoryId", "select id, name from plantLifeHistories order by  displayOrder, name", expData.Item("hostPlantLifeHistoryId"), false, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantGrowthHabitId") %>Host Plant Growth Habit:</td>
		<td><%
			response.write dbBuildSelect("hostPlantGrowthHabitId", "select id, name from plantGrowthHabits order by displayOrder, name", expData.Item("hostPlantGrowthHabitId"), false, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantPhotoPathId") %>Host Plant Photosynthetic Pathway:</td>
		<td><%
			response.write dbBuildSelect("hostPlantPhotoPathId", "select id, name from plantPhotoPaths order by  displayOrder, name", expData.Item("hostPlantPhotoPathId"), false, false)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostPlantFamily") %>Host Plant Family:</td>
		<td><input type="text" name="<% = DB_FIELD %>hostPlantFamily" size=30 value="<% = expData.Item("hostPlantFamily") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostGenus") %>Host Genus:</td>
		<td><input type="text" name="<% = DB_FIELD %>hostGenus" size=30 value="<% = expData.Item("hostGenus") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "hostSpecies") %>Host Species:</td>
		<td><input type="text" name="<% = DB_FIELD %>hostSpecies" size=30 value="<% = expData.Item("hostSpecies") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "plantSourceId") %>Plant Source:</td>
		<td><%
			response.write dbBuildSelect("plantSourceId", "select id, name from plantSources order by  displayOrder, name", expData.Item("plantSourceId"), false, false)
		%></td>
	</tr>

	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

