<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentList.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.6 $
' Purpose:	main data entry page
' Author:		Lawrence Walters
'	modified:
'	2006-01-17	LLW	removed join with expSites
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Data Entry Step 3 - Experiments"
ShowClock = false
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors
set errors = server.createobject("Scripting.Dictionary")

RequireLogin()

' determine paper id here
if len(request.querystring(DB_FIELD & "paperId")) > 0 then
	Session("paperId") = request.querystring(DB_FIELD & "paperId")
end if
Session.Contents.Remove("experimentId")

' handle delete here
if len(request.querystring("delete")) > 0 then
	if isnumeric(request.querystring("delete")) then
		dbDelete "experiments", request.querystring("delete"), errors
		message = "Experiment and all associated data deleted."
	end if
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=5 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=5><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td colspan=5><input type="button" value="Add new experiment" onclick="document.location='edExperiment.asp'">&nbsp;<a href="edExperimentList.asp?view=detail">Detail View</a>&nbsp;<a href="edExperimentList.asp">Summary View</a></td>
	</tr>
<%
'list old papers here with edit links
dim rs
set rs = server.createobject("ADODB.Recordset")
if request.querystring("view") = "detail" then
	sql = "select * from ExportExperiments where paperId = " & Session("paperId")
else
	sql = "select experiments.id as experimentId, experiments.name, year, countries.name as countryName, environments.name as environmentName, mycorrhizaeTypes.name as mycorrhizaeName from ((experiments left outer join environments on environments.id = experiments.environmentId) left outer join mycorrhizaeTypes on mycorrhizaeTypes.id = experiments.mycorrhizaeTypeId) left outer join countries on countries.id = experiments.countryId where experiments.paperId = " & Session("paperId")
end if

rs.Open sql, gConn, adOpenForwardOnly

' old form: has inner join with expSites
'rs.Open "select experiments.id, experiments.name, year, countries.name as countryName, environments.name as environmentName, mycorrhizaeTypes.name as mycorrhizaeName from (((experiments left outer join expSites on expSites.id = experiments.expSiteId) left outer join environments on environments.id = experiments.environmentId) left outer join mycorrhizaeTypes on mycorrhizaeTypes.id = experiments.mycorrhizaeTypeId) left outer join countries on countries.id = expSites.countryId where experiments.paperId = " & Session("paperId"), gConn, adOpenForwardOnly

response.write "<tr>" & vbcrlf
if request.querystring("view") = "detail" then
	for each field in rs.fields
		response.write "<td class=""edColumnTitle"">" & field.name & "</td>" & vbcrlf
	next
else
%>
		<td class="edColumnTitle">Name</td>
		<td class="edColumnTitle">Year</td>
		<td class="edColumnTitle">Country</td>
		<td class="edColumnTitle">Environment</td>
		<td class="edColumnTitle">Myco. Type</td>
		<td class="edColumnTitle" colspan="4">&nbsp;</td>
<%
end if
response.write "<tr>" & vbcrlf

do while not rs.eof
	if rowHighlight = "odd" then
		rowHighlight = "even"
	else
		rowHighlight = "odd"
	end if

	response.write "<TR class='" & rowHighlight & "'>" & vbcrlf

	if request.querystring("view") = "detail" then
		for each field in rs.fields
			response.write "<td>" & field.value & "</td>" & vbcrlf
		next
	else
		response.write "<td width=20% valign=top>" & rs("name") & "</td>"
		response.write "<td width=10% valign=top>" & rs("year") & "</td>"
		response.write "<td width=20% valign=top>" & rs("countryName") & "</td>"
		response.write "<td width=20% valign=top>" & rs("environmentName") & "</td>"
		response.write "<td width=20% valign=top>" & rs("mycorrhizaeName") & "</td>"
	end if


	' links
	response.write "<td valign=top>"

	' setup experiment link
	response.write "<input type=""button"" class='buttonSmall' value=""Setup"" onclick=""document.location='edExperiment.asp?" & DB_FIELD & "id=" & rs("experimentId") & "'"">"

	' treatments/responses link
	response.write "<input type=""button"" class='buttonSmall' value=""Treatments"" onclick=""document.location='edExpTreatments.asp?" & DB_FIELD & "id=" & rs("experimentId") & "'"">"

	' results input link
	response.write "<input type=""button"" class='buttonSmall' value=""Results"" onclick=""document.location='edExpResults.asp?" & DB_FIELD & "id=" & rs("experimentId") & "'"">"

	' delete experiment link
	response.write "<input type=""button"" class='buttonSmall' value=""Delete"" onclick=""if(ConfirmDelete()) {document.location='edExperimentList.asp?delete=" & rs("experimentId") & "'}"">"
	response.write "</td>"
	response.write "</TR>"
	rs.movenext
loop
rs.close
set rs = nothing
%>
	<tr>
		<td colspan=2>&nbsp;</td>
	</tr>
	<tr>
		<td colspan=2><input type="button" name="Papers" value="Papers" onclick="document.location='enterdata.asp'"></td>
	</tr>
</table>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

