<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edExperimentSoilNutrients.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.4 $
' Purpose:	setup fixed experiment parameters
' Author:		Lawrence Walters
'
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmMain." & DB_FIELD & "soilNitrogen"
PageTitle = "Data Entry Step 4e - Soil Nutrient Details"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, expData, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set expData = Server.CreateObject("Scripting.Dictionary")

'required fields
required = array()

'numeric fields
numeric = array("soilNitrogen", "soilPhosphorous")

' user clicked next
if request.form("Next") = "Save and move to next page" then
	'validate data
	valid = true

	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then	valid = ValidateNumeric(numeric, errors)

	if valid then

		'update data
		id = dbInput("experiments", errors)

		if errors.count = 0 then
			'redirect to next page
			response.redirect "edExperimentHostPlant.asp"
			response.end
		else
			' fill in data dictionary with submitted values
			' we only get here when there are errors.
			set expData = FormRead()
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set expData = FormRead()

' user clicked back
elseif request.form("Back") = "Back" then
	'redirect to first experiment page
	response.redirect "edExperimentBelowGround.asp"

' read data for experiment from querystring
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set expData = dbRead("experiments", request.querystring(DB_FIELD & "id"))

' read data for experiment from session variable
elseif len(Session("experimentId")) > 0 then
	set expData = dbRead("experiments", Session("experimentId"))

' new experiment
else
	expData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = expData("id") %>">
<input type="hidden" name="<% = DB_FIELD %>paperId" value="<% = Session("paperId") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
	<tr>
		<td colspan=2 class="edHeader">Experiment Name: <% =expData.Item("name") %></td>
	</tr>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>



	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>
	<tr>
		<td class="note" colspan="99">For both N and P, if both Total and Available/Extractable are reported, enter Available/Extractable. If unclear whether Total or Available/Extractable is reported, do not enter it.</td>
	</tr>

	<tr>
		<td class="edHeader" colspan="99">Ambient Soil Nitrogen <span class="note">(before experiment)</span></td>
	</tr>
	<tr>
		<td colspan="99"><table>
			<tr>
				<td class="edMedium"><% = MarkRequiredField(required, "soilNitrogen") %>Value:</td>
				<td><input type="text" name="<% = DB_FIELD %>soilNitrogen" size=5 value="<% = expData.Item("soilNitrogen") %>"></td>
				<td class="edMedium"><% = MarkRequiredField(required, "soilNTypeId") %>Total/Avail</td>
				<td><%
					response.write dbBuildSelect("soilNTypeId", "select id, name from soilNutrientTypes order by displayOrder, name", expData.Item("soilNTypeId"), false, false)
				%></td>
		</tr>
		<tr>
				<td class="edMedium"><% = MarkRequiredField(required, "soilNUnitId") %>Units</td>
				<td><%
					response.write dbBuildSelect("soilNUnitId", "select id, name from soilNutrientUnits order by displayOrder, name", expData.Item("soilNUnitId"), false, false)
					%></td>
				<td class="edMedium"><% = MarkRequiredField(required, "soilNMeasurementId") %>Method of measurement:</td>
				<td><%
					response.write dbBuildSelect("soilNMeasurementId", "select id, name from soilNutrientMeasurements order by displayOrder, name", expData.Item("soilNMeasurementId"), false, false)
				%></td>
			</tr>
		</table></td>
	</tr>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>
	<tr>
		<td class="edHeader" colspan="99">Ambient Soil Phosphorous <span class="note">(before experiment)</span></td>
	</tr>
	<tr>
		<td colspan="99"><table>
			<tr>
				<td class="edMedium"><% = MarkRequiredField(required, "soilPhosphorous") %>Value:</td>
				<td><input type="text" name="<% = DB_FIELD %>soilPhosphorous" size=5 value="<% = expData.Item("soilPhosphorous") %>"></td>
				<td class="edMedium"><% = MarkRequiredField(required, "soilPTypeId") %>Total/Avail</td>
				<td><%
					response.write dbBuildSelect("soilPTypeId", "select id, name from soilNutrientTypes order by displayOrder, name", expData.Item("soilPTypeId"), false, false)
				%></td>
		</tr>
		<tr>
				<td class="edMedium"><% = MarkRequiredField(required, "soilPUnitId") %>Units</td>
				<td><%
					response.write dbBuildSelect("soilPUnitId", "select id, name from soilNutrientUnits order by displayOrder, name", expData.Item("soilPUnitId"), false, false)
				%></td>
				<td class="edMedium"><% = MarkRequiredField(required, "soilPMeasurementId") %>Method of measurement:</td>
				<td><%
					response.write dbBuildSelect("soilPMeasurementId", "select id, name from soilNutrientMeasurements order by displayOrder, name", expData.Item("soilPMeasurementId"), false, false)
				%></td>
			</tr>
		</table></td>
	</tr>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "soilpH") %>Ambient soil pH:</td>
		<td><input type="text" name="<% = DB_FIELD %>soilpH" size=5 value="<% = expData.Item("soilpH") %>"></td>
	</tr>
	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>
	<tr>
		<td class="edHeader" colspan="99">Fertilizer</td>
	</tr>
	<tr>
		<td class="note" colspan="99">Fertilizer added to whole experiment (if added as a treatment, choose No here). Hoagland's solution (and other nutrient solutions such as Long-Ashton and Hewitt) contains N, P, K and micronutrients.</td>
	</tr>
	<tr>
		<td width="10%" class="edHeader"><% = MarkRequiredField(required, "fertN") %>N:</td>
		<td><%
			response.write dbBuildSelect("fertN", "", expData.Item("fertN"), false, true)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertP") %>P:</td>
		<td><%
			response.write dbBuildSelect("fertP", "", expData.Item("fertP"), false, true)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "fertK") %>K:</td>
		<td><%
			response.write dbBuildSelect("fertK", "", expData.Item("fertK"), false, true)
		%></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "micronutrients") %>Micronutrients:</td>
		<td><%
			response.write dbBuildSelect("micronutrients", "", expData.Item("micronutrients"), false, true)
		%></td>
	</tr>

	<tr>
		<td><img alt="" src="images/spacer.gif" height=5></td>
	</tr>

	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

