<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edPaper.asp,v $
' $Date: 2006/01/19 05:16:39 $
' $Revision: 1.7 $
' Purpose:	first step of paper data entry
' Author:		Lawrence Walters
'
'	modified:
'	2005-08-03	LLW	fixed error when adding new journal - the session variable is checked to be not "new" before reading from the database
'	2005-10-25	LLW	commented out article link entry
'	2005-11-20	LLW	added timer
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject, ShowClock
FocusObject = "frmMain." & DB_FIELD & "journalId"
PageTitle = "Data Entry Step 1 - Paper details"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, data, required, numeric, cnt, errors, valid
set errors = server.createobject("Scripting.Dictionary")
set data = Server.CreateObject("Scripting.Dictionary")

' required fields
required = array("year", "title", "journalId")
' numeric fields
numeric = array("year")

' data was submitted
if request.form("Next") = "Save and move to next page" then
	'validate data here
	valid = true
	
	' check for all required fields
	valid = ValidateRequired(required, errors)
	
	' check for all numeric input fields
	if valid then valid = ValidateNumeric(numeric, errors)
	
	'update database
	if valid then
		id = dbInput("papers", errors)
		
		if errors.count = 0 then
			Session("paperId") = id
			'redirect to next page
			response.redirect "edPaperAuthors.asp"
			response.end
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set data = FormRead()
	
' back button was pressed
elseif request.form("Back") = "Back" then
	response.redirect "enterdata.asp"
	response.end
	
' editing previously entered paper
elseif len(request.form(DB_FIELD & "id")) > 0 and request.form(DB_FIELD & "id") <> "new" then
	'todo: load old values here
	set data = dbRead("papers", request.form(DB_FIELD & "id"))

' editing previously entered paper
elseif len(request.querystring(DB_FIELD & "id")) > 0 and request.querystring(DB_FIELD & "id") <> "new" then
	'load old values here
	set data = dbRead("papers", request.querystring(DB_FIELD & "id"))

' user pressed the "back" button from the next page
' or entered a new journal
elseif len(session("paperId")) > 0 and session("paperId") <> "new" then
	'load old values here
	set data = dbRead("papers", session("paperId"))

' new paper
else
	data.add "id", "new"
end if

session("paperId") = data.Item("id")
%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<form name="frmMain" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = data.Item("id") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "journalId") %>Journal:</td>
		<td><%
			response.write dbBuildSelect("journalId", "select id, name from journals order by name", data.Item("journalId"), true, false)
		%><input type="button" value="Add Journal" onclick="document.location='edJournal.asp?paperId=<% = data.Item("id") %>'"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "title") %>Title:</td>
		<td><textarea cols="60" rows="5" name="<% = DB_FIELD %>title" style="font-family: arial"><% = data.Item("title") %></textarea></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "year") %>Year:</td>
		<td><input type="text" name="<% = DB_FIELD %>year" size=6 value="<% = data.Item("year") %>"></td>
	</tr>
<!-- commented out because article link field is no longer needed with PDF upload feature working	
	<tr>
		<td class="edHeader">Article Link:</td>
		<td><input type="text" name="<% = DB_FIELD %>articleLink" size=60 value="<% = data.Item("articleLink") %>"></td>
	</tr>
-->
	<tr>
		<td colspan=2 class="edRequired">Fields marked with an asterisk (*) are required.</td>
	</tr>
	<tr>
		<td colspan=2>&nbsp;</td>
	</tr>
	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Back" value="Back">
		<span style="width:25px">&nbsp;</span><input type="submit" name="Next" value="Save and move to next page"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

