<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edPaperSaveUpload.asp,v $
' $Date: 2005/12/03 00:06:06 $
' $Revision: 1.2 $
' Purpose:	save uploaded pdf file for a paper
' Author:		Lawrence Walters
'
' Modified:
'	2005-10-19	LLW	added paper id to file save name to prevent duplicates
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = ""
PageTitle = "Data Entry Step 3 - Saving Paper Upload"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<!-- #INCLUDE FILE="include/upload.inc.asp"-->

<%
dim sql, rs
Dim objUpload
Dim strFileName
Dim strPath

RequireLogin()

Set oFSO = Server.CreateObject("Scripting.FileSystemObject")

' Compile path to save file to
strPath = Server.MapPath(".\" & PDF_PATH) & "\"

' check for paperId session variable
paperId = session("paperId")
if len(paperId) = 0 then
	response.redirect "edPaperSaveUpload.asp?error=No paper id found. File not uploaded."
	response.end
end if

' Instantiate Upload Class
Set objUpload = New clsUpload

' Grab the file name
strFileName = objUpload.Fields(DB_FIELD & "pdfUrl").FileName

' check for no filename
if len(strFileName) =  0 then
	response.redirect "edPaperUpload.asp?error=No file was selected to upload."
	response.end
end if

' require PDF file only
if objUpload.Fields(DB_FIELD & "pdfUrl").FileExt <> "PDF" and objUpload.Fields(DB_FIELD & "pdfUrl").FileExt <> "ZIP" then
	response.redirect "edPaperUpload.asp?error=Only PDF and ZIP files are allowed."
	response.end
end if

' check if file is too long (default length limit is 204,800)
if Request.TotalBytes > 204800 then
	response.redirect "edPaperUpload.asp?error=File is too large. Maximum upload size is 200KB. Try zipping the file first."
	response.end
end if

'delete old paper if there is one
set rs = Server.CreateObject("ADODB.Recordset")
sql = "select pdfUrl from papers where id = " & paperId
rs.Open sql, gConn, adOpenForwardOnly
if not rs.eof then
	if len(rs(0)) > 0 then
		if oFSO.FileExists(strPath & rs(0)) then
			oFSO.DeleteFile(strPath & rs(0)), true
		end if
	end if
	rs.close
end if
set rs = nothing

' replace any quotation marks in the file
strFileName = replace(strFileName, "'", "_")
strFileName = replace(strFileName, """", "_")

' add paper id to beginning of file name to create unique file names
strFileName = CStr(paperId) & "_" & strFileName

' Save the binary data to the file system
objUpload(DB_FIELD & "pdfUrl").SaveAs strPath & strFileName

' write the file name to the database
sql = "update papers set pdfUrl = '" & strFileName & "', userId = " & session("userId") & " where id = " & paperId
gConn.execute sql

' Release upload object from memory
Set objUpload = Nothing
Set oFSO = Nothing

response.redirect "edExperimentList.asp"

%>
