<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: edSite.asp,v $
' $Date: 2006/01/19 05:16:39 $
' $Revision: 1.4 $
' Purpose:	main data entry page
' Author:		Lawrence Walters
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
FocusObject = "frmNewSite." & DB_FIELD & "countryId"
PageTitle = "Data Entry Step 3a - Add an Site"
ShowClock = true
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
RequireLogin()

dim id, siteData, required, numeric, cnt, errors, valid, site
set errors = server.createobject("Scripting.Dictionary")
set siteData = Server.CreateObject("Scripting.Dictionary")

' required fields
required = array("countryId", "state")

' numeric fields
numeric = array("easting", "northing", "zoneNumber")

' check for no more sites
if request.form("Cancel") = "Cancel" then
	'todo: redirect to experiments
	response.redirect "edExperiment.asp"

' add was clicked	
elseif request.form("Add this site") = "Add this site" then
	'validate siteData
	valid = true

	' check for all required fields
	valid = ValidateRequired(required, errors)

	' check for all numeric fields
	if valid then valid = ValidateNumeric(numeric, errors)
	
	if valid then
		'add site to sites table
		id = dbInput("expSites", errors)
		
		'redirect to paper site page
		if errors.count = 0 then
			' redirect here
			response.redirect "edExperiment.asp"
			response.end
		end if
	end if

	' fill in data dictionary with submitted values
	' we only get here when there are errors.
	set siteData = FormRead()

' edit site
elseif len(request.querystring(DB_FIELD & "id")) > 0 then
	set siteData = dbRead("expSites", request.querystring(DB_FIELD & "id"))
	
' new site
else
	siteData.add "id", "new"
end if

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=2 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if
%>
<form name="frmNewSite" action="<% = Request.servervariables("PATH_INFO") %>" method="POST">
<input type="hidden" name="<% = DB_FIELD %>id" value="<% = siteData.item("id") %>">
<input type="hidden" name="<% = DB_FIELD %>userId" value="<% = Session("userId") %>">
<input type="hidden" name="<% = DB_FIELD %>dateEntered" value="<% = Now() %>">
<!-- create a new site -->
	<tr>
		<td colspan=2>Create a new site:</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "countryId") %>Country:</td>
		<td><%
			response.write dbBuildSelect("countryId", "select id, name from countries order by name", siteData.Item("countryId"), true, false)
		%></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "state") %>State:</td>
		<td><input type="text" name="<% = DB_FIELD %>state" size=60 value="<% = siteData.Item("state") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "name") %>Name:</td>
		<td><input type="text" name="<% = DB_FIELD %>name" size=60 value="<% = siteData.Item("name") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "latitude") %>Latitude:</td>
		<td><input type="text" name="<% = DB_FIELD %>latitude" size=10 value="<% = siteData.Item("latitude") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "longitude") %>Longitude:</td>
		<td><input type="text" name="<% = DB_FIELD %>longitude" size=10 value="<% = siteData.Item("longitude") %>"></td>
	</tr>
	<tr>
		<td class="edHeader">OR</td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "easting") %>UTM Easting:</td>
		<td><input type="text" name="<% = DB_FIELD %>easting" size=10 value="<% = siteData.Item("easting") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "northing") %>UTM Northing:</td>
		<td><input type="text" name="<% = DB_FIELD %>northing" size=10 value="<% = siteData.Item("northing") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "zoneNumber") %>UTM Zone Number:</td>
		<td><input type="text" name="<% = DB_FIELD %>zoneNumber" size=2 value="<% = siteData.Item("zoneNumber") %>"></td>
	</tr>
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "zoneLetter") %>UTM Zone Letter:</td>
		<td><input type="text" name="<% = DB_FIELD %>zoneLetter" size=2 value="<% = siteData.Item("zoneLetter") %>"></td>
	</tr>	
	<tr>
		<td class="edHeader"><% = MarkRequiredField(required, "utmDatumId") %>Map Datum:</td>
		<td><%
			response.write dbBuildSelect("utmDatumId", "select id, name from utmDatums order by name", siteData.Item("utmDatumId"), false)
		%></td>
	</tr>
	<tr>
		<td colspan=2 class="edRequired">Fields marked with an asterisk (*) are required.</td>
	</tr>
	<tr>
		<td colspan=2>&nbsp;</td>
	</tr>
	<tr>
		<td colspan=2><span style="width:25px">&nbsp;</span><input type="reset" name="Reset"><span style="width:25px">&nbsp;</span><input type="submit" name="Cancel" value="Cancel"><span style="width:25px">&nbsp;</span><input type="submit" name="Add this site" value="Add this site"></td>
	</tr>
</table>
</form>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

