<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: init.inc.asp,v $
' $Date: 2005/12/03 00:06:51 $
' $Revision: 1.7 $
' Purpose:	all include files listed here
' Author:		Lawrence Walters
''''''''''''''''''''''''''''''''''''''''''''''''''''
'todo: turn error handling on for production
'On Error Resume Next

%>
<!-- #INCLUDE FILE="database.inc.asp" -->
<!-- #INCLUDE FILE="login.inc.asp" -->

<%

' Session timeout... this is set in session start, application start, but 
' it does not appear to work very well.
Session.Timeout = 100

' Compile path to save file to
const PDF_PATH = "fpdb"		' yeah, its dumb to put it in the same place as the database, but the nau servers are really annoying about setting write permissions to other folders. This one was already set through front page when the database was put there, so...

' connect to the database
dbConnect()

' track this user's activity
trackUserLogins()

'******************************************************************
'Function:			WriteDebugInfo
'Description:		display form and query variables
'Parameters:		none
'Return:				none
'Author:				Lawrence Walters
'*******************************************************************/
sub WriteDebugInfo()
	dim objItem, intLoop 
	
	if showDebugInfo = false then exit sub
	
	Response.Write "<br><b>Debug info</b><br>" 

	Response.Write "Session.Timeout: " & Session.Timeout
	
	if Request.Form.Count > 0 then
		Response.Write "<br>Form variables:<br>"
		for each objItem in Request.Form
			if Request.Form(objItem).Count > 1 then
				Response.Write objItem & ":<br>"
				for intLoop = 1 to Request.Form(objItem).Count
					Response.Write "Subkey " & intLoop & " value = " _
						& Request.Form(objItem)(intLoop) & "<br>"
				next
			else
				Response.Write objItem & " = " & Request.Form(objItem) & "<br>"
			end if
		next
	end if
		
	if Request.QueryString.Count > 0 then
		Response.Write "<br>Query string:<BR>"
		for each objItem in Request.QueryString
			Response.Write objItem & " = " & Request.QueryString(objItem) & "<br>"
		next
	end if
	
	if Request.Cookies.Count > 0 then
		Response.Write "<br>Cookies:<BR>"
		for each objItem in Request.Cookies
			Response.Write objItem & " = " & Request.Cookies(objItem) & "<br>"
		next
	end if
	
	if Session.Contents.Count > 0 then
		Response.Write "<br>Session Variables:<BR>"
		for each objItem in Session.Contents
			Response.Write objItem & " = " & Session.Contents(objItem) & "<br>"
		next
	end if
end sub

'******************************************************************
'Function:			MarkRequiredField
'Description:		put a marker next to fields that are required
'Parameters:		arr - array of required field names
'								field - name of this field
'Return:				html
'Author:				Lawrence Walters
'*******************************************************************/
function MarkRequiredField(arr, field)
	dim html
	for cnt = lbound(arr) to ubound(arr)
		if arr(cnt) = field then
			html = "<span class=""edRequired"">*</span>"
			exit for
		end if
	next
	MarkRequiredField = html
end function

'******************************************************************
'Function:			ValidateRequired
'Description:		check for required fields
'Parameters:		arr - array of required field names
'								errors - dictionary of error messages
'Return:				true/false
'Author:				Lawrence Walters
'*******************************************************************/
function ValidateRequired(arr, byref errors)
	dim cnt, retval
	retval = true
	' check for all required fields
	for cnt = lbound(arr) to ubound(arr)
		if len(request.form(DB_FIELD & arr(cnt))) = 0 then
			errors.add errors.count + 1, "The " & arr(cnt) & " field is required."
			retval = false
		end if
	next
	ValidateRequired = retval
end function

'******************************************************************
'Function:			ValidateNumeric
'Description:		check for numeric fields
'Parameters:		arr - array of required field names
'								errors - dictionary of error messages
'Return:				true/false
'Author:				Lawrence Walters
'*******************************************************************/
function ValidateNumeric(arr, byref errors)
	dim cnt, retval
	retval = true
	' check for all numeric fields
	for cnt = lbound(arr) to ubound(arr)
		if len(request.form(DB_FIELD & arr(cnt))) > 0 and not isnumeric(request.form(DB_FIELD & arr(cnt))) then
			errors.add errors.count + 1, "The " & arr(cnt) & " field must be a number."
			retval = false
		end if
	next
	ValidateNumeric = retval
end function

'******************************************************************
'Function:			GetStats
'Description:		check for numeric fields
'Parameters:		papers - number of papers
'								experiments - number of experiments entered
'Return:				
'Author:				Lawrence Walters
'*******************************************************************/
sub GetStats(byref papers, byref experiments)
	' get total papers, experiments
	sql = "select count(*) from experiments"
	set rs = server.createobject("ADODB.Recordset")
	rs.open sql, gConn, adOpenForwardOnly
	if not rs.eof then
		experiments = rs.fields(0)
		rs.close
	end if
	
	sql = "select count(*) from papers"
	set rs = server.createobject("ADODB.Recordset")
	rs.open sql, gConn, adOpenForwardOnly
	if not rs.eof then
		papers = rs.fields(0)
		rs.close
	end if
end sub

function GetSortLink(column, title)
	dim retval

	' flip it!
	if Session("sort") = column then
		column = column  & " desc"
	end if
	
	retval = "<a href='" & Request.ServerVariables("SCRIPT_NAME") & "?sort=" & column & "' title='Sort by " & title & "'>" & title & "</a>" 

	GetSortLink = retval
end function

function GetSortSql()
	dim retval
	if len(Request.Querystring("sort")) > 0 then
		retval = Request.Querystring("sort")
		Session("sort") = retval
		GetSortSql = " order by " & retval
	else
		retval = null
		GetSortSql = retval
		Session("sort") = null
	end if

end function
%>

