<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: login.inc.asp,v $
' $Date: 2005/12/03 00:06:51 $
' $Revision: 1.7 $
' Purpose:	login functions
' Author:		Lawrence Walters
'
'	modified:
'	2005-08-03	LLW	redirect to default page on logon - this prevents issues with incorrect/missing session variables
'									added changePassword() function
''''''''''''''''''''''''''''''''''''''''''''''''''''

' user info class
class UserData
	public id
	public FirstName
	public LastName
	public Email
	public IsAdmin
	
	sub UserData_Initialize()
		IsAdmin = false
		id = -1
	end sub
end class

'******************************************************************
'Function:			IsLoggedIn
'Description:		is the user logged in?
'Parameters:		none
'Return:				true/false
'Author:				Lawrence Walters
'*******************************************************************/
public function IsLoggedIn() 
	IsLoggedIn = Session("LoggedIn") 
end function

'******************************************************************
'Function:			isAdmin
'Description:		is the user an administrator?
'Parameters:		none
'Return:				true/false
'Author:				Lawrence Walters
'*******************************************************************/
public function isAdmin()
	if Session("isAdmin") = 1 then
		isAdmin = true
	else
		isAdmin = false
	end if
end function

'******************************************************************
'Function:			ResetPassword
'Description:		reset a user's password and then email them the new password
'Parameters:		email - user's email address
'Return:				result of reset
'Author:				Lawrence Walters
'*******************************************************************/
public function ResetPassword(email) 
	dim rs, retval, sql, id
	
	' read submitted data
	if len(email) = 0 then
		retval = "You must enter an email address"
	else
		' check against database
		set rs = Server.CreateObject("ADODB.Recordset")
		sql = "SELECT * FROM users WHERE email = '" & email & "'"
		'response.write sql
		'exit function
		rs.Open sql, gConn
		'success:
		if not rs.eof then
			' create a new password
			newPassword = "cobdym" & Second(Now())
			
			' reset password
			sql = "update users set password = '" & newPassword & "' where id = " & rs("id")
			rs.close
			set rs = nothing
			gConn.Execute sql
			
			' send an email to the user
			'declare variables for the mail object (oMail) and the email body (strEmailBody) 
			Dim oMail, strEmailBody
			
			'Create the CDO object
			Set oMail = Server.CreateObject("CDONTS.NewMail")
	
			'creates the email using the oMail object and the string strEmailBody
			oMail.To = email
			oMail.From = "MycoDB Admin <vbc2@dana.ucc.nau.edu>"
			strEmailBody = "Your MycoDB password has been reset at your request" & "<BR>" & _
				"Your new password is " & "<BR>" & "<BR>" & _
				newPassword & "<BR>" & "<BR>" & _
				"Login at <a href=""" & request.servervariables("SERVER_NAME") & "/login.asp"">" & request.servervariables("SERVER_NAME") & "/mycodb/login.asp</a><BR>" & "<BR>" & _
				"Reset requested from address: " & request.servervariables("REMOTE_ADDR") & "/" & request.servervariables("REMOTE_HOST") & "<BR>" & _ 
				"This message automatically generated from " & request.servervariables("SERVER_NAME") & request.servervariables("SCRIPT_NAME") & "<BR>"

			oMail.Subject = "MycoDB" 
			oMail.BodyFormat = 0
			oMail.MailFormat = 0
			oMail.Body = strEmailBody
			oMail.Send
			
			'Resets the oMail object to Nothing
			Set oMail = Nothing
			retval = "Your password has been reset. You should receive an email with the new password shortly."			
		'email not found
		else
			' display error message
			retval = "That email address is not in our database. Please check the spelling and try again, or register."
		end if
	end if
	ResetPassword = retval
end function

'******************************************************************
'Function:			ValidateLogin
'Description:		check a user's credentials when logging in - redirect to login page if invalid
'Parameters:		email - user's email address
'								password - user entered password
'								target - target page to redirect to after successful login
'Return:				error message if necessary
'Author:				Lawrence Walters
'*******************************************************************/
public function ValidateLogin(email, password, target) 
	dim rs, retval, sql
	
	' read submitted data
	if len(email) = 0 then
		retval = "You must enter an email address"
	elseif len(password) = 0 then
		retval = "You must enter a password"
	else
		
		' check against database
		set rs = Server.CreateObject("ADODB.Recordset")
		sql = "SELECT * FROM users WHERE email = '" & email & "' and password = '" & password & "'"
		'response.write sql
		'exit function
		rs.Open sql, gConn
		'success:
		if not rs.eof then
			'check if user is disabled
			if rs("isDisabled") = 1 then
				retval = "Your account has been disabled"
				rs.close
				set rs = nothing
			else
				' save user id in session variable
				Session("userId") = rs("id")
				Session("LoggedIn") = true
				Session("isAdmin") = rs("isAdmin")
				
				' count logged in user
				Application.Lock
					Application("LoggedInUsers") = Application("LoggedInUsers") + 1
				Application.UnLock
				
				rs.close
				set rs = nothing
				
				' add entry to userLogins
				sql = "delete from userLogins where userId = " & Session("userId")
				gConn.Execute sql
				sql = "insert into userLogins (userId, loginTime, currentPage) values (" & Session("userId") & ", Now(), '" & Request.ServerVariables("script_name") & "')"
				gConn.Execute sql
				
				' redirect to target page
				'response.redirect target
				response.redirect "default.asp"
				response.end
			end if
			
		'failure:
		else
			' display error message
			retval = "Invalid email or password."
		end if
	end if
	
	ValidateLogin = retval
end function

'******************************************************************
'Function:			RequireLogin
'Description:		check if the user is logged in and has access to this page - redirect to login page if they are not logged in 
'Parameters:		none
'Return:				none
'Author:				Lawrence Walters
'*******************************************************************/
public sub RequireLogin()
	' check if logged in
	if IsLoggedIn() = false then
		'redirect to login page
		response.redirect "login.asp?LoginResponse=You must login to access this resource.&Target=" & Request.ServerVariables("PATH_INFO")
	end if
end sub

'******************************************************************
'Function:			RequireAdmin
'Description:		check if the user is an administrator - redirect to login page if they are not logged in 
'Parameters:		none
'Return:				none
'Author:				Lawrence Walters
'*******************************************************************/
public sub RequireAdmin()
	' check if logged in
	if isAdmin() = false then
		'redirect to Admin page
		response.redirect "login.asp?LoginResponse=You must have admin rights to access this resource.&Target=" & Request.ServerVariables("PATH_INFO")
	end if
end sub

'******************************************************************
'Function:			LoadUserData
'Description:		get details about a user 
'Parameters:		none
'Return:				UserData object
'Author:				Lawrence Walters
'*******************************************************************/
public function LoadUserData()
	' get user id from session variable
	dim userId, rs, sql, user
	userId = Session("userId")
	if userId <> -1 then
		sql = "select * from users where id = " & userId
		set rs = server.createobject("ADODB.Recordset")
		rs.open sql, gConn
		if not rs.eof then
			set user = new UserData
			user.id = userId
			user.FirstName = rs("FirstName")
			user.LastName = rs("LastName")
			user.Email = rs("Email")
			user.IsAdmin = rs("IsAdmin")
			rs.close
			set rs = nothing
			set LoadUserData = User
			
		end if
	end if
end function

'******************************************************************
'Function:			ChangePassword
'Description:		let a user change his password 
'Parameters:		userId, current password, new password, pasword confirmation
'Return:				message
'Author:				Lawrence Walters
'*******************************************************************/
public function ChangePassword(userId, currentPassword, newPassword, newPasswordConfirm)
	dim retval, rs, sql
	
	if len(currentPassword) = 0 then
		retval = "Must enter your current password."
	elseif len(newPassword) = 0 then
		retval = "Must enter a new password."
	elseif len(newPasswordConfirm) = 0 then
		retval = "Must enter a password confirmation."
	elseif newPasswordConfirm <> newPassword then
		retval = "New password and confirmation do not match."
	end if
	
	if len(retval) > 0 then
		ChangePassword = retval
		exit function
	end if
	
	' verify current password
	sql = "select * from users where id = " & userId & " and password = '" & currentPassword & "'"
	set rs = server.createobject("ADODB.Recordset")
	rs.open sql, gConn, adOpenForwardOnly
	
	' successful if a recordset is returned
	if not rs.eof then
		rs.close
		sql = "update users set password = '" & newPassword & "' where id = " & userId
		gConn.execute sql
		retval = "Password changed successfully."
	else
		retval = "Current password not valid."
	end if
	set rs = nothing
	
	ChangePassword = retval
end function

'******************************************************************
'Function:			Register
'Description:		add a new user 
'Parameters:		email, firstname, lastname, password, pw confirm
'Return:				message if unsuccessful, otherwise redirect to default page
'Author:				Lawrence Walters
'*******************************************************************/
public function Register(email, firstName, lastName, password, confirm)
	dim retval, sql, rs
	
	if len(email) = 0 then
		retval = "Must enter email address."
	elseif len(firstName) = 0 then
		retval = "Must enter first name."
	elseif len(lastName) = 0 then
		retval = "Must enter last name."
	elseif len(password) = 0 then
		retval = "Must enter password."
	elseif len(confirm) = 0 then
		retval = "Must confirm password."
	elseif password <> confirm then
		retval = "Password and password confirmation do not match."
	elseif len(password) < 6 then
		retval = "Password must be at least 6 characters long."
	end if
	
	if len(retval) > 0 then
		Register = retval
		exit function
	end if

	sql = "insert into users (email, password, firstname, lastname, isadmin) values('" & email & "','" & password & "','" & firstname & "','" & lastname & "',0)"
	gConn.execute sql

	ValidateLogin email, password, "default.asp"
	
end function

'******************************************************************
'Function:			Logout
'Description:		logoff the current user 
'Parameters:		none
'Return:				none
'Author:				Lawrence Walters
'*******************************************************************/
public sub Logout()

	' delete my login
	sql = "delete from userLogins where userId = " & Session("userId")
	gConn.Execute sql
	
	Application.Lock
		if Application("LoggedInUsers") > 0 then Application("LoggedInUsers") = Application("LoggedInUsers") - 1
	Application.UnLock
	Session.Contents.RemoveAll
	response.redirect "default.asp"
end sub

'******************************************************************
'Function:			TrackLogins
'Description:		update the database with the user's activity 
'Parameters:		none
'Return:				none
'Author:				Lawrence Walters
'*******************************************************************/
public sub trackUserLogins()

	' update the logins table if we're logged in
	if IsLoggedIn() then
		' delete expired logins
		' session.timeout is in minutes - subtract those minutes from the current time
		sql = "delete from userLogins where loginTime < (Now() - " & (Session.Timeout / (60 * 24)) & ")"
		gConn.Execute sql
		
		' update this user's record in userLogins table
		sql = "update userLogins set loginTime = Now(), currentPage = '" & Request.ServerVariables("script_name") & "' where userId = " & Session("userId")
		gConn.Execute sql
	end if
	
end sub


%>

