<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: reviewList.asp,v $
' $Date: 2006/01/20 20:40:08 $
' $Revision: 1.6 $
' Purpose:	show a list of all experiments.
' Author:		Lawrence Walters
'	modified:
'	2006-01-17	LLW	removed join with expSites
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Review Experiment"
ShowClock = false
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors
set errors = server.createobject("Scripting.Dictionary")

RequireLogin()

dim rsPaper, rsExperiment, rsTreatments, rsResults
set rsPaper = server.createobject("ADODB.Recordset")
set rsExperiment = server.createobject("ADODB.Recordset")
set rsTreatments = server.createobject("ADODB.Recordset")
set rsResults = server.createobject("ADODB.Recordset")

' get the data!
sql = "select experimentId, name, ecosystem, climate, country, closestCity, environment, mycorrhizaeType, year, month, soilNitrogen, soilNNutrientMeasurement, soilNNutrientUnit, soilNNutrientType, soilPhosphorous, soilPNutrientMeasurement, soilPNutrientUnit, soilPNutrientType, sterilizationMethod, hostPlantNative, plantLifeHistory, plantPhotoPath, plantGrowthHabit, numWeeks, hostGenus, hostSpecies, hostPlantFamily, plantSource, userName, dateEntered, inoculumSpecies, growthMedium, timeCourseStudy, experimentalUnit, experimentalPotSize, inocFieldSoil, inocRoots, inocSpores, inocMycelia, inocPotCulture, fungiSource, nonMycoControl, fertN, fertP, fertK, micronutrients from ExportExperiments where experimentId=" & request.querystring("id")
rsExperiment.Open sql, gConn, adOpenForwardOnly

sql = "select lastName1 as Author1, lastName2 as Author2, lastName3 as Author3, Title, year, name as Journal from paperSummaryWithExperiments where experimentId=" & request.querystring("id")
rsPaper.Open sql, gConn, adOpenForwardOnly

sql = "select expTreatments.id as id, treatments.id as treatmentId, treatments.name as treatmentName, treatments.description as treatmentNotes, [level] from treatments left outer join expTreatments on treatments.id = expTreatments.treatmentId where expTreatments.experimentId = " & request.Querystring("id") & " order by treatments.displayOrder, expTreatments.id, [level] asc"
rsTreatments.Open sql, gConn, adOpenForwardOnly


' quick summary name
experimentName = rsPaper("Author1") & " " & rsPaper("year") & " " & rsExperiment("name")
PageTitle = experimentName

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<table width=100%>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=5 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=99><% = message %></td>
	</tr>
<%                                         
end if
%>
	<tr>
		<td colspan=99><a href="reviewList.asp" title="go back to the experiment list">Back</a>&nbsp;|&nbsp;<a href="#Setup" title="Go down to the experiment details">Setup</a>&nbsp;|&nbsp;<a href="#Treatments" title="Go down to the treatments">Treatments</a>&nbsp;|&nbsp;<a href="#Results" title="Go down to the experiment results">Results</a></td>
	</tr>
	<tr>
		<td colspan="99">Entered by <% = rsExperiment("userName") %></td>
	</tr>	
</table>

<%
' list the paper details
%>
<h3>Paper Details: <% = experimentName %></h3>
<table>
<%
' List the papers

do while not rsPaper.eof
	for each field in rsPaper.fields
		if className = "odd" then
			className = "even"
		else
			className = "odd"
		end if
	
		response.write "<tr class=" & className & ">" & vbcrlf
	
		response.write "<td>" & field.name & "</td>"
		response.write "<td>" & field.value & "</td>"
	
		response.write "</tr>" & vbcrlf
	next
	rsPaper.movenext
loop
%>
</table>

<%

' list the experiment details
response.write "<a name='Setup'></a>"
%>
<h3>Experiment Setup Details: <% = experimentName %></h3>
<table>
<%

do while not rsExperiment.eof
	response.write "<tr class='odd'>"
	response.write "<td>Name / Id</td>"
	response.write "<td>" & rsExperiment("name") & " / " & rsExperiment("experimentId") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>Location (country/city)</td>"
	response.write "<td>" & rsExperiment("country") & " / " & rsExperiment("closestCity") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>ecosystem / climate</td>"
	response.write "<td>" & rsExperiment("ecosystem") & " / " & rsExperiment("climate") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>environment</td>"
	response.write "<td>" & rsExperiment("environment") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>mycorrhizaeType</td>"
	response.write "<td>" & rsExperiment("mycorrhizaeType") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>year</td>"
	response.write "<td>" & rsExperiment("year") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>month</td>"
	response.write "<td>" & rsExperiment("month") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>soilNitrogen</td>"
	response.write "<td>" & rsExperiment("soilNitrogen") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>soilNNutrientMeasurement</td>"
	response.write "<td>" & rsExperiment("soilNNutrientMeasurement") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>soilNNutrientUnit</td>"
	response.write "<td>" & rsExperiment("soilNNutrientUnit") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>soilNNutrientType</td>"
	response.write "<td>" & rsExperiment("soilNNutrientType") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>soilPhosphorous</td>"
	response.write "<td>" & rsExperiment("soilPhosphorous") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>soilPNutrientMeasurement</td>"
	response.write "<td>" & rsExperiment("soilPNutrientMeasurement") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>soilPNutrientUnit</td>"
	response.write "<td>" & rsExperiment("soilPNutrientUnit") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>soilPNutrientType</td>"
	response.write "<td>" & rsExperiment("soilPNutrientType") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>sterilizationMethod</td>"
	response.write "<td>" & rsExperiment("sterilizationMethod") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>hostPlantNative</td>"
	response.write "<td>" & rsExperiment("hostPlantNative") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>plantLifeHistory</td>"
	response.write "<td>" & rsExperiment("plantLifeHistory") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>plantPhotoPath</td>"
	response.write "<td>" & rsExperiment("plantPhotoPath") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>plantGrowthHabit</td>"
	response.write "<td>" & rsExperiment("plantGrowthHabit") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>numWeeks</td>"
	response.write "<td>" & rsExperiment("numWeeks") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>hostGenus</td>"
	response.write "<td>" & rsExperiment("hostGenus") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>hostSpecies</td>"
	response.write "<td>" & rsExperiment("hostSpecies") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>hostPlantFamily</td>"
	response.write "<td>" & rsExperiment("hostPlantFamily") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>plantSource</td>"
	response.write "<td>" & rsExperiment("plantSource") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>userName</td>"
	response.write "<td>" & rsExperiment("userName") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>dateEntered</td>"
	response.write "<td>" & rsExperiment("dateEntered") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>inoculumSpecies</td>"
	response.write "<td>" & rsExperiment("inoculumSpecies") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>growthMedium</td>"
	response.write "<td>" & rsExperiment("growthMedium") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>timeCourseStudy</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("timeCourseStudy")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>experimentalUnit</td>"
	response.write "<td>" & rsExperiment("experimentalUnit") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>experimentalPotSize</td>"
	response.write "<td>" & rsExperiment("experimentalPotSize") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>inocFieldSoil</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("inocFieldSoil")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>inocRoots</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("inocRoots")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>inocSpores</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("inocSpores")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>inocMycelia</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("inocMycelia")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>inocPotCulture</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("inocPotCulture")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>fungiSource</td>"
	response.write "<td>" & rsExperiment("fungiSource") & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>nonMycoControl</td>"
	response.write "<td>" & rsExperiment("nonMycoControl") & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>fertN</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("fertN")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>fertP</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("fertP")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='even'>"
	response.write "<td>fertK</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("fertK")) & "</td>"
	response.write "</tr>"
	response.write "<tr class='odd'>"
	response.write "<td>micronutrients</td>"
	response.write "<td>" & ConvertDataToYesNo(rsExperiment("micronutrients")) & "</td>"
	response.write "</tr>"

	rsExperiment.movenext
loop

%>
</table>

<%

' list the treatments
response.write "<a name='Treatments'></a>"
%>
<h3>Treatments: <% = experimentName %></h3>
<table>
	<tr>
		<td width=20% class="edHeader">Treatment</td>
		<td width=5% class="edHeader">#</td>
		<td width=25% class="edHeader">Level</td>
		<td width=50% class="edHeader">Notes</td>
	</tr>
<%
'list old papers here with edit links
dim levelCount, lastTreatmentId, sql, className
levelCount = 0
lastTreatmentId = -1

do while not rsTreatments.eof
	if lastTreatmentId <> rsTreatments("treatmentId") then
		levelCount = 0
		className = "rowBreak"
	else
		className = ""
	end if
	levelCount = levelCount + 1
	lastTreatmentId = rsTreatments("treatmentId")

	response.write "<tr>" & vbcrlf
	response.write "<td class=" & className & " valign=top>"

	' show the treatment name once
	if levelCount = 1 then
		response.write rsTreatments("treatmentName")
	else
		response.write "&nbsp;"
	end if

	response.write "</td>" & vbcrlf

	response.write "<td class=" & className & " valign=top>" & levelCount & "</td>" & vbcrlf

	' write input box for level
	response.write "<td class=" & className & " valign=top>" & rsTreatments("level") & "</td>" & vbcrlf
	response.write "</td>" & vbcrlf

	' also show notes only once
	if levelCount = 1 then
		response.write "<td rowspan='3' class='" & className & " note' valign=top>"
		response.write rsTreatments("treatmentNotes")
		response.write "</td>" & vbcrlf
	end if

	response.write "</tr>" & vbcrlf
	rsTreatments.movenext
loop

%>
</table>

<%
' list the results
response.write "<a name='Results'></a>"
response.write "<h3>Results: " & experimentName & "</h3>"
' list each treatment set, the treatment levels, and then textboxes to enter results
' original

outputResultForm request.querystring("id")


rsPaper.close
set rsPaper = nothing
rsTreatments.close
set rsTreatments = nothing
rsExperiment.close
set rsExperiment = nothing


function ConvertDataToYesNo(input)
	if input = 1 then
		ConvertDataToYesNo = "Yes"
	elseif input = 0 then
		ConvertDataToYesNo = "No"
	elseif input = 255 then
		ConvertDataToYesNo = "Unknown"
	else
		ConvertDataToYesNo = input
	end if
end function



sub outputResultForm(experimentId)
	dim rsTreatments
	dim arrLevels()
	' how many treatments variables?
	' get treatments in order
	sql = "select distinct treatmentId, treatments.name, treatments.displayOrder from expTreatments, treatments where experimentId = " & experimentId & " and expTreatments.treatmentid = treatments.id order by treatments.displayOrder"
	'displaySQL sql
	set rsTreatments = server.createobject("ADODB.Recordset")
	set rsLevels = server.createobject("ADODB.Recordset")
	set dictTreatments = server.createobject("scripting.dictionary")

	rsTreatments.Open sql, gConn, adOpenStatic
	do while not rsTreatments.eof
		' get all the levels for this treatment
		sql2 = "select [level] from expTreatments where treatmentId = " & rsTreatments("treatmentId") & " and experimentId = " & experimentId & " order by [level]"
		'displaySQL sql2
		rsLevels.Open sql2, gConn, adOpenForwardOnly
		set dictLevel = server.createobject("scripting.dictionary")
		do while not rsLevels.eof
			' add levels to a keyed array of some sort?
			dictLevel.add CStr(rsLevels.fields("level").value), rsLevels.fields("level").value
			rsLevels.movenext
		loop
		rsLevels.close

		' add these levels to a parent dictionary
		dictTreatments.add CStr(rsTreatments.fields("treatmentId").value), dictLevel

		rsTreatments.movenext
	loop
	rsTreatments.Close

	' get levels in order
	set dictSQL = server.createobject("scripting.dictionary")

	' for each treatment variable
	for each treatmentId in dictTreatments.keys
		' make a sql statement that restricts, do it in order, last to first
		BuildSQLDict experimentId, treatmentId, dictSQL, dictTreatments(treatmentId)
	next

	response.write "<table>"
	for each sql in dictSQL.items
		if trtSetRowClass = "treatmentSetEven" then
			trtSetRowClass = "treatmentSetOdd"
		else
			trtSetRowClass = "treatmentSetEven"
		end if

		rsTreatments.Open sql, gConn, adOpenStatic
		'displaySQL "select * from expTrtSetSummary where id in (" & sql & ") order by displayOrder"
		OutputTreatmentSet experimentId, trtSetRowClass, rsTreatments("id")
		rsTreatments.close
	next
	response.write "</table>"
end sub

sub BuildSQLDict(experimentId, treatmentId, byref dictSQL, byref dictLevels)
	dim mySQL
	'response.write "BuildSQL Dictionary: " & experimentId & " / " & treatmentId & "<br>"

	set myDict = server.createobject("scripting.dictionary")
	if dictSQL.count = 0 then
		dictSQL.add 1, ""
	end if

	for each mySQL in dictSQL.items
		for each level in dictLevels
			'response.write "BuildSQLDict: " & makesql(mySQL, experimentId, treatmentId, level) & "</br>"
			myDict.add myDict.count + 1, makesql(mySQL, experimentId, treatmentId, level)
		next
	next
	set dictSQL = myDict
end sub

function makesql(firstSQL, newExperimentId, newTreatmentId, newLevel)
	sql = "select id from expTrtSetSummary where treatmentId = " & newTreatmentId & " and experimentId = " & newExperimentId & " and [level] = '" & newLevel & "'"

	if len(firstSQL) > 0 then
		sql = sql & " and id in (" & firstSQL & ")"
	end if
	makesql = sql
end function

sub OutputTreatmentSet(experimentId, rowClass, treatmentSetId)
	set rs2 = server.createobject("ADODB.recordset")
	fields = array("mean", "stdError", "stdDev", "confInter95", "lsd", "numReplicates")
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' treatment set
	'
	' each row contains treatments, responses, and input boxes
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	response.write "<tr class='" & rowClass & "'>" & vbcrlf


	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' treatments summary
	'
	' name and levels
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	response.write "<td class='bdrTop' style='vertical-align: top'><table width=100% border=0 cellpadding=2 cellspacing=0 >" & vbcrlf
	' header
	response.write "<tr><td class='resultHeader'>Treatment</td>" & vbcrlf
	response.write "<td class='resultHeader'>Level</td></tr>" & vbcrlf
	sql = "select * from expTrtSetSummary where experimentId = " & experimentId & " and id = " & treatmentSetId & " order by displayOrder"
	rs2.Open sql, gConn, adOpenForwardOnly
	do while not rs2.eof
		response.write "<tr>" & vbcrlf
		' treatment name
		response.write "<td class='bdrTopThin edSmall' valign=top>" & rs2("name") & "</td>" & vbcrlf

		' treatment level
		response.write "<td class='bdrTopThin edSmall' valign=top>" & rs2("level") & "</td>" & vbcrlf
		response.write "</tr>" & vbcrlf
		rs2.movenext
	loop
	rs2.close
	response.write "</table></td>" & vbcrlf

	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'
	' results
	'
	' response variable name and values
	'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	' results input - new cell
	response.write "<td colspan=3 valign=top class='bdrTop'>"

	' sub table
	response.write "<table width=100% border=0 cellpadding=2 cellspacing=0><tr>" & vbcrlf

	' header
	response.write "<td class='resultHeader'>Response</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Mean</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Std Error</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>Std Dev</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>95% CI</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'>LSD</td>" & vbcrlf
	response.write "<td class='resultHeader' style='text-align: center'># Replicates</td>" & vbcrlf
	response.write "</tr>" & vbcrlf

	'todo: change from order by name to order by displayOrder
	' after new form of this view is copied to server
	sql = "select * from expResultSummary where experimentId = " & experimentId & " and expTrtSetId = " & treatmentSetId & " order by responseDisplayOrder, responseName"
	rs2.Open sql, gConn, adOpenForwardOnly
	do while not rs2.eof

		if rowHighlight = "odd" then
			rowHighlight = "even"
		else
			rowHighlight = "odd"
		end if

		response.write "<tr class='" & rowHighlight & "'>" & vbcrlf

		' response variable name
		response.write "<td class='edSmall'>" & rs2("responseName") & "</td>" & vbcrlf

		' results - mean, std Error and # replicates
		for i = lbound(fields) to ubound(fields)
			if not isnull(rs2(fields(i))) then
				if len(CStr(rs2(fields(i)))) > 0 then
					response.write "<td class='resultInput'>"
					
					' show input boxes for admins
					if isAdmin() then
						response.write "<input type=textbox class='edSmallTextBox' name='" & DB_FIELD & fields(i) & rs2("id") & "' value='" & rs2(fields(i)) & "' size='3'>"
					else
						response.write rs2(fields(i))
					end if
					
					response.write "</td>" & vbcrlf
				else
					response.write "<td><strong>" & rs2(fields(i)) & "</strong</td>" & vbcrlf
				end if
			else
				response.write "<td><strong>" & rs2(fields(i)) & "</strong</td>" & vbcrlf
			end if
		next
		response.write "</tr>" & vbcrlf
		rs2.movenext
	loop
	rs2.close
	response.write "</table></td>" & vbcrlf
	response.write "</tr>" & vbcrlf

end sub


sub displaySQL(sql)
	set rs = server.createobject("adodb.recordset")

	rs.Open sql, gConn, adOpenStatic

	if rs.state = adStateOpen then
		rs.movelast
		records = rs.recordcount
		numHierarchies = rs.recordcount
		rs.movefirst

		response.write "<br><br><table id=""results"">"
		response.write "<tr><td colspan=""99"">SQL: " & sql & "</td></tr>"
		response.write "<tr><td colspan=""99"">Records: " & records & "</td></tr>"
		response.write "<tr>"
		for each field in rs.fields
			response.write "<th>" & field.name & "</th>" & vbcrlf
		next
		response.write "</tr>"

		response.write "<tr>"
		do while not rs.eof
			response.write "<tr>"
			for each field in rs.fields
				response.write "<td>" & field.value & "</td>" & vbcrlf
			next
			rs.movenext
			response.write "</tr>"
		loop
		response.write "</table>"
	else
		response.write "no records returned"
	end if
end sub

%>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->

