<%@ Language="VBScript"%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''
' MycoDB - online database of mycorrhizal experiments 
' Copyright (C) 2007  Lawrence Walters
'
' This program is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
' 
' $RCSfile: adminExport.asp,v $
' $Date: 2005/12/03 00:05:53 $
' $Revision: 1.2 $
' Purpose:	export all data
' Author:		Lawrence Walters
'
'	modified:
'	2005-10-27	LLW added multiple export buttons
''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim PageTitle, FocusObject
PageTitle = "Export"
%>
<!-- #INCLUDE FILE="include/init.inc.asp" -->
<%
dim message, errors, level, oldNumLevels, rs, sql, name, i, targetType
set errors = server.createobject("Scripting.Dictionary")
set rs = server.createobject("ADODB.Recordset")

RequireLogin()

%>
<!-- #INCLUDE FILE="include/header.inc.asp" -->
<script type="text/javascript" src="scripts/search.js.asp"></script>
<form name="frmMain" action="searchExport.asp" method="POST">
<table width=100% border=0>
<%
if errors.count > 0 then
	dim str
	for each str in errors
%>
	<tr>
		<td colspan=3 class="error"><% = errors(str) %></td>
	</tr>
<%
	next
end if

if len(message) > 0 then
%>
	<tr>
		<td colspan=3><% = message %></td>
	</tr>
<%
end if
%>
	<tr>
		<td height="40px" colspan="99">Click to export all data to a comma separated values file file. The options below are not real "filters." They simply limit the number of columns in the output. If using Excel to view this data, you will run into its limit of 256 columns if you select everything below.</td>
	</tr>
	<tr><td>Choose your conversions and calculated columns</td></tr>
	<tr class="odd">
		<td class='edSmall'><input type="checkbox" class='edSmallCheckbox'  name="convertSoilNAndPToPPM" checked="checked"/>Convert Soil N and P to parts per million</td>
	</tr>
	<tr class="even">
		<td class='edSmall'><input type="checkbox" class='edSmallCheckbox'  name="calculateNtoPRatios"  id="calculateNtoPRatios" onclick="CheckBoxesForNtoPRatio()" />Calculate N to P ratios (shoot N/P, root N/P, total N/P)</td>
	</tr>
<%

set rs = server.createobject("ADODB.Recordset")

' list all of the treatments here
' don't show inoculum - it will always be included
sql = "select id, name, displayOrder, experimentCount from experimentsPerTreatment order by displayOrder, name"

rs.Open sql, gConn, adOpenStatic
numCols = 2
rowsPerColumn = CInt(rs.RecordCount/numCols) + 1
currentCol = 1
currentRow = 1
width = 100/numCols
%>
	<tr><td>Choose what treatments you would like to see</td></tr>
	<tr>
		<td colspan='99'><table cellpadding=2 cellspacing=0 width="100%">
			<tr>
				<td valign='top' width="<% = width %>%"><table cellpadding=0 cellspacing=2>
<%
dim rowClass
do while not rs.eof
	if rowClass="even" then
		rowClass="odd"
	else
		rowClass="even"
	end if

	response.write "<TR class='" & rowClass & "'>"   & vbcrlf

	response.write "<td valign=top>" & vbcrlf

	' write checkbox
	response.write "<input type='checkbox' class='edSmallCheckbox' name='" & DB_FIELD & "treatment_" & rs("id") & "' id='" & DB_FIELD & "treatment_" & rs("id") & "'  >"

	response.write "</td>" & vbcrlf
	response.write "<td width=100% valign=top class='edSmall'>" & rs("name") & " (" & rs("experimentCount") & ")</td>" & vbcrlf
	response.write "</TR>" & vbcrlf
	rs.movenext
	currentRow = currentRow + 1
	if currentRow > rowsPerColumn and not rs.eof then
		response.write "</table></td>"
		response.write "				<td valign='top' width='" & width & "%'><table cellpadding=0 cellspacing=2>"
		currentRow = 1
	end if
loop
response.write "</table></td></tr></table></td></tr>"
rs.close


' list all of the responses here
sql = "select id, name, displayOrder, experimentCount from experimentsPerResponse order by displayOrder, name"

rs.Open sql, gConn, adOpenStatic
numCols = 2
rowsPerColumn = CInt(rs.RecordCount/numCols) + 1
currentCol = 1
currentRow = 1
width = 100/numCols
%>
	<tr><td>Choose what response variables you would like to see</td></tr>
	<tr>
		<td colspan='99'><table cellpadding=2 cellspacing=0 width="100%">
			<tr>
				<td valign='top' width="<% = width %>%"><table cellpadding=0 cellspacing=2>
<%
do while not rs.eof
	if rowClass="even" then
		rowClass="odd"
	else
		rowClass="even"
	end if

	response.write "<TR class='" & rowClass & "'>"   & vbcrlf

	response.write "<td valign=top>" & vbcrlf

	' write checkbox
	response.write "<input type='checkbox' class='edSmallCheckbox' name='" & DB_FIELD & "response_" & rs("id") & "' id='" & DB_FIELD & "response_" & rs("id") & "' >"

	response.write "</td>" & vbcrlf
	response.write "<td width=100% valign=top class='edSmall'>" & rs("name") & " (" & rs("experimentCount") & ")</td>" & vbcrlf
	response.write "</TR>" & vbcrlf
	rs.movenext
	currentRow = currentRow + 1
	if currentRow > rowsPerColumn and not rs.eof then
		response.write "</table></td>"
		response.write "				<td valign='top' width='" & width & "%'><table cellpadding=0 cellspacing=2>"
		currentRow = 1
	end if
loop
response.write "</table></td></tr></table></td></tr>"
rs.close

' get counts of the different result variables here
sql = "select * from resultTypeCount"
rs.Open sql, gConn, adOpenStatic

%>
	<tr>
		<td>Select the result values you want:</td>
	</tr>
	<tr>
		<td><table>
		<tr class="odd">
			<td><input type="checkbox"  class='edSmallCheckbox' name="<% = DB_FIELD %>result_mean" id="<% = DB_FIELD %>result_mean" checked="checked" /></td>
			<td class='edSmall'>Mean (<% = rs("countMean") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="<% = DB_FIELD %>result_stdError"  /></td>
			<td class='edSmall'>Standard Error (<% = rs("countStdError") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="<% = DB_FIELD %>result_stdDev" checked="checked" /></td>
			<td class='edSmall'>Standard Deviation (<% = rs("countStdDev") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="calcSumN" /></td>
			<td class='edSmall'>sum(n)</td>			
		</tr>
		<tr class="even">
			<td><input type="checkbox" class='edSmallCheckbox'  name="<% = DB_FIELD %>result_confInter95" /></td>
			<td class='edSmall'>95% Confidence Interval (<% = rs("countConfInter95") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="<% = DB_FIELD %>result_lsd" /></td>
			<td class='edSmall'>LSD (<% = rs("countLsd") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="<% = DB_FIELD %>result_numReplicates" checked="checked" /></td>
			<td class='edSmall'># Replicates (<% = rs("countNumReplicates") %>)</td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="calcSumNRecip" /></td>
			<td class='edSmall'>1 / sum(n)</td>
		</tr>
		<tr class="odd">
			<td colspan="6"/></td>
			<td><input type="checkbox" class='edSmallCheckbox'  name="calcLnResponseRatio" /></td>
			<td class='edSmall'>ln(response ratio)</td>
		</tr>		
		</table></td>
	</tr>
	<tr>
		<td><input type="submit" name="Export" value="Export All Data" />&nbsp;<input type="submit" name="Export" value="Random Subset" />&nbsp;<input type="submit" name="Export" value="Debug" onclick="document.frmMain.action='searchExportDebug.asp'" /></td>
	</tr>
</table>
</form>
<%
rs.close
set rs = nothing
%>
<!-- #INCLUDE FILE="include/footer.inc.asp" -->


